//************************************** Bouton{} *********************************************
class Bouton {
    float   x0              = 0F;
    float   x               = 0F;
    float   y               = 0F;
    float   l               = 0F;
    float   h               = 0F;
    float   l0              = 0F;
    float   h0              = 0F;
    String  texte_affiche;
    String  texte_confirmation;
    String  titre_choix;
    String  texte_choix[]   = new String[50];
    int     nb_choix        = 0;
    float   largeur_choix   = 0F;
    String  texte_choisi;
    boolean choix[]         = new boolean[50];
    int     valeur_bouton   = 0;
    int     adresse_saisie  = -1;
    int     CV17            = 0;
    int     CV18            = 0;
    int     modif_CV29      = 0;
    int     numero_saisi    = -1;
    boolean valide          = false;
    String  dixieme_mm;
    
    Bouton() {}

    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        image(gros_bleu, _x, _y, _l, _h);
        textAlign(CENTER, CENTER);
        fill(NOIR);        
        text(texte_affiche, _x+_l/2, _y+_h/2F);
        x = _x; y = _y; l = _l; h = _h;
    }
    //--------------------------------- effacer_les_boutons() -------------------------
    void effacer_les_boutons() {
        ajouter_decodeur       = false;
        maj_decodeur           = false;
        copier_CV              = false;
        coller_CV              = false;
        choix_du_vehicule      = false;
        sortir_sans_sauver     = false;
        //sauver_et_sortir       = false;
        choix_vehicule         = false;
        dans_curseurH_vehicule = false;
        for (int i = 0; i < 5; i++) {
            choix[i]           = false;
            groupe = groupes[0];
            groupe.Boutons[i+8].texte_choisi = null;
        }
        couleur_echelle        = false;
        couleur_moteur         = false;
        couleur_DCC            = false;
        couleur_marque         = false;
        couleur_proprietaire   = false;
    }
    //------------------------------ choisir_filtre() ----------------------------------
    void choisir_filtre(int _filtre) {
        textFont(Courier12);
        float taille_texte = textWidth(titre_choix);
        gestion.dessine_rectangle_inverse(width/2F-taille_texte/2F-20F, height/2F-(60F+15F*nb_choix)/2F, taille_texte+40F, 60F+15F*nb_choix);
        textAlign(CENTER);
        text(titre_choix, width/2F, height/2F-(60F+15F*nb_choix)/2F+20F);
        gestion.dessine_rectangle(width/2F-largeur_choix/2F, height/2F-(60F+15F*nb_choix)/2F+40F, largeur_choix, 6+15*nb_choix);
        textFont(Courier14);
        textAlign(LEFT);
        int compte_choix = -1;
        for (int i = 0; i < nb_choix; i++) {
            compte_choix++;
            texte_choisi = texte_choix[compte_choix];
            if (mouseX > width/2F-largeur_choix/4F                                    && mouseX < width/2F+largeur_choix/4F
             && mouseY > height/2F-(60F+15F*nb_choix)/2F+40F+15F+15F*compte_choix-10F && mouseY < height/2F-(60F+15F*nb_choix)/2F+40F+15F+15F*compte_choix-10F+15F) {
                if (!mousePressed) {
                    fill(NOIR);
                    imageMode(CENTER);
                    image(affiche_bleu, width/2F, height/2F-(60F+15F*nb_choix)/2F+40F+10F+15F*compte_choix, textWidth(texte_choisi), 15);
                } else {
                    tous_vehicules.clear();
                    int compte_vehicules = -1;
                    switch (_filtre) {
                        //-------------- echelle -----------------
                        case 0 :
                            couleur_echelle = true;
                            for (Vehicule veh0 : tous_vehicules_filtres) {
                                if (veh0.echelle.equals(texte_choisi)) {
                                    compte_vehicules++;
                                    veh0.ID = compte_vehicules;
                                    tous_vehicules.add(veh0);
                                }
                            }
                            break;
                        //--------------- moteur ----------------
                        case 1 :
                            couleur_moteur = true;
                            for (Vehicule veh0 : tous_vehicules_filtres) {
                                if (texte_choisi.equals("Moteur")) {
                                    if (veh0.moteur) {
                                        compte_vehicules++;
                                        veh0.ID = compte_vehicules;
                                        tous_vehicules.add(veh0);
                                    }
                                } else {
                                    if (!veh0.moteur) {
                                        compte_vehicules++;
                                        veh0.ID = compte_vehicules;
                                        tous_vehicules.add(veh0);
                                    }
                                }
                            }
                            break;
                        //--------------- DCC ----------------
                        case 2 :
                            couleur_DCC = true;
                            for (Vehicule veh0 : tous_vehicules_filtres) {
                                if (texte_choisi.equals("DCC")) {
                                    if (veh0.dcc) {
                                        compte_vehicules++;
                                        veh0.ID = compte_vehicules;
                                        tous_vehicules.add(veh0);
                                    }
                                } else {
                                    if (!veh0.dcc) {
                                        compte_vehicules++;
                                        veh0.ID = compte_vehicules;
                                        tous_vehicules.add(veh0);
                                    }
                                }
                            }
                            break;
                        //-------------- marque -----------------
                        case 3 :
                            couleur_marque = true;
                            for (Vehicule veh0 : tous_vehicules_filtres) {
                                if (veh0.marque.equals(texte_choisi)) {
                                    compte_vehicules++;
                                    veh0.ID = compte_vehicules;
                                    tous_vehicules.add(veh0);
                                }
                            }
                            break;
                        //-------------- proprietaire -----------------
                        case 4 :
                            couleur_proprietaire = true;
                            for (Vehicule veh0 : tous_vehicules_filtres) {
                                int CV106 = -1;
                                for (Proprietaire prop0 : tous_proprietaires) {
                                    if (prop0.CV106 == int(texte_choisi)) {
                                        CV106 = prop0.CV106;
                                        break;
                                    }
                                }
                                if (veh0.CV[106] == CV106) {
                                    compte_vehicules++;
                                    veh0.ID = compte_vehicules;
                                    tous_vehicules.add(veh0);
                                }
                            }
                            break;
                    }
                    //--------------------- si on ne trouve rien, on retire le dernier choix -----------
                    if (tous_vehicules.size() == 0) {
                        for (Vehicule veh0 : tous_vehicules_filtres) {
                            tous_vehicules.add(veh0);
                        }
                        groupe = groupes[0];
                        switch (_filtre) {
                            case 0 :
                                couleur_echelle = false;
                                groupe.Boutons[8].texte_choisi = null;
                                titre_choix = "Cette échelle n'est pas compatible avec les précédents choix";
                                break;
                            case 1 :
                                couleur_moteur = false;
                                groupe.Boutons[9].texte_choisi = null;
                                titre_choix = "Cette option pour le moteur n'est pas compatible avec les précédents choix";
                                break;
                            case 2 :
                                couleur_DCC = false;
                                groupe.Boutons[10].texte_choisi = null;
                                titre_choix = "Cette option pour le DCC n'est pas compatible avec les précédents choix";
                                break;
                            case 3 :
                                couleur_marque = false;
                                groupe.Boutons[11].texte_choisi = null;
                                titre_choix = "Cette marque n'est pas compatible avec les précédents choix";
                                break;
                            case 4 :
                                couleur_proprietaire = false;
                                groupe.Boutons[12].texte_choisi = null;
                                titre_choix = "Ce nom de propriétaire n'est pas compatible avec les précédents choix";
                                break;
                        }
                        taille_texte = textWidth(titre_choix);
                        gestion.dessine_rectangle_inverse(width/2F-taille_texte/2F-20F, height/2F-(60F+15F)/2F, taille_texte+40F, 60F+15F);
                        textAlign(CENTER);
                        text(titre_choix, width/2F, height/2F-(60F+15F)/2F+20F);
                    } else {
                        tous_vehicules_filtres.clear();
                        for (Vehicule veh0 : tous_vehicules) {
                            tous_vehicules_filtres.add(veh0);
                        }
                        for (int j = 0; j < 5; j++) {
                            choix[j] = false;
                        }
                    }
                    vehicule = tous_vehicules.get(0);
                    choix_du_vehicule = true;
                    break;
                }
            } else {
                fill(BLANC);
            }                        
            textAlign(CENTER);
            text(texte_choisi, width/2F, height/2F-(60F+15F*nb_choix)/2F+40F+15F+15F*compte_choix);
        }
    }
    //---------------------------- effacer_choix() -----------------------------
    void effacer_choix() {
        for (int i = 0; i < 45; i++) {
            texte_choix[i] = "-";
        }
    }
    //---------------------------- compte_choix() -----------------------------
    void compte_choix() {
        nb_choix      = 0;
        largeur_choix = 0F;
        int choix_courant = 0;
        while (!texte_choix[choix_courant].equals("-")) {
            nb_choix++;
            if (texte_choix[choix_courant].substring(0, 1).equals("(")) {
                largeur_choix = max(largeur_choix, textWidth(texte_choix[choix_courant].substring(18)));
            } else {
                largeur_choix = max(largeur_choix, textWidth(texte_choix[choix_courant]));
            }
            choix_courant++;
        }
    }
    //----------------------------- liste_choix() -----------------------------
    void liste_choix(int _bouton) {
        if (titre_choix != null) {
            if (choix[_bouton]) {
                textFont(Courier12);
                float taille_texte = textWidth(titre_choix);
                gestion.dessine_rectangle_inverse(x+60F-taille_texte, y, taille_texte+40F, 60F+15F*nb_choix);
                textAlign(CENTER);
                text(titre_choix, x+60F-taille_texte+(taille_texte+40F)/2F, y+20F);
                gestion.dessine_rectangle(x+60F-taille_texte+(taille_texte+40F-largeur_choix)/2F, y+15F+15F*nb_choix, largeur_choix, 6+15*nb_choix);
                textFont(Courier14);
                textAlign(LEFT);
                int compte_choix = -1;
                for (int i = 0; i < nb_choix; i++) {
                    compte_choix++;
                    String texte_de_choix = texte_choix[compte_choix];
                    if (mouseX > x+60F-taille_texte+(taille_texte+40F)/2F-largeur_choix/2F && mouseX < x+60F-taille_texte+(taille_texte+40F)/2F+largeur_choix/2F
                     && mouseY > y+60F+15F*compte_choix-15F                                && mouseY < y+60F+15F*compte_choix) {
                        if (!mousePressed) {
                            fill(NOIR);
                            imageMode(CENTER);
                            image(affiche_bleu, x+60F-taille_texte+(taille_texte+40F)/2F, y+60F+15F*compte_choix-4F, largeur_choix-20F, 15F);
                        } else {
                            texte_choisi   = texte_de_choix;
                            valeur_bouton  = compte_choix;
                            choix[_bouton] = false;
                            break;
                        }
                    } else {
                        fill(BLANC);
                    }                        
                    textAlign(CENTER);
                    text(texte_de_choix.substring(18), x+60F-taille_texte+(taille_texte+40F)/2F, y+60F+15F*compte_choix);
                }                
            }
        }
    }
    //-------------------------- dessine_bouton_bleu() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle(x0, y, l0, h0); //<>// //<>//
        textFont(Courier14); //<>// //<>//
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        imageMode(CORNER);
        if (texte_choisi == null) {
            image(affiche_bleu, x+130F, y+5F, l, h);
            fill(NOIR);
            textAlign(LEFT, CENTER);       
            text(texte_choix[valeur_bouton].substring(0,18), x, y+1F+h/2F);
            textAlign(CENTER, CENTER);       
            text(texte_choix[valeur_bouton].substring(18), x0+l0-l/2F/*270F*/, y+1F+h/2F);
        } else {
            if (CV29 == vehicule.CV[29]) {
                image(affiche_bleu, x+130F, y+5F, l, h);
                texte_choisi = null;
            } else {
                image(affiche_vert, x+130F, y+5F, l, h);
            }
            fill(NOIR);
            textAlign(LEFT, CENTER);       
            text(texte_choix[valeur_bouton].substring(0,18), x, y+1F+h/2F);
            textAlign(CENTER, CENTER);       
            text(texte_choix[valeur_bouton].substring(18), x0+l0-l/2F/*270F*/, y+1F+h/2F);
        }
    }
    //-------------------------- dessine_bouton_bleu_modifie() -------------------------------
    void dessine_bouton_bleu_modifie(boolean _vert) {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle(x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        imageMode(CORNER);
        if (_vert) {
            image(affiche_vert, x+130F, y+5F, l, h);
        } else {
            image(affiche_bleu, x+130F, y+5F, l, h);
        }
        fill(NOIR);
        textAlign(LEFT, CENTER);       
        text(texte_choix[valeur_bouton].substring(0,18), x, y+1F+h/2F);
        textAlign(CENTER, CENTER);       
        text(texte_choix[valeur_bouton].substring(18), x+270F, y+1F+h/2F);
    }
    //------------------------------- CV29_bin_dec() ----------------------------------------------
    void CV29_bin_dec() {
        CV29 = 0;
        for (int i = 1; i < 9; i++) {
            CV29 = CV29 + int(groupe.Boutons[i].valeur_bouton*pow(2, i-1));                                                   //  2 puissance (i-1)
        }
    }
    //---------------------------- veleur_mm() ---------------------------------
    void valeur_mm(int _dixieme) {
        dixieme_mm = str(int(_dixieme/10F))+"."+str(int(_dixieme-10F*int(_dixieme/10F)));
    }
    //---------------------------- methodes vides ------------------------------
    void description_bouton() {}
    void appui_bouton() {}
}
//*********************************************************************************************
//************************************* boutons particuliers **********************************
//*********************************************************************************************
//*********************************************************************************************
class Precedent extends Bouton {
    Precedent() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        image(bouton_bleu, _x, _y, _l, _h);        
        stroke(NOIR);
        noFill();
        strokeWeight(1.5F);
        rect(_x, _y, 20F, 20F, 2, 2, 2, 2);
        fill(NOIR);
        triangle(_x+15F, _y+5F, _x+15F, _y+15F, _x+5F, _y+10F);
        noStroke();
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        int identite = vehicule.ID;
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                identite = max(0, identite-1);
                vehicule = tous_vehicules.get(identite);
                if (copier_CV && !coller_CV) {
                    vehicule_copie = identite;
                }
                gestion.largeur_curseur[0] = gestion.l0*vehicule.ID/(tous_vehicules.size()-1);
            }
        }
    }
}
//*********************************************************************************************
class Suivant extends Bouton {
    Suivant() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        image(bouton_bleu, _x, _y, _l, _h);
        stroke(NOIR);
        noFill();
        strokeWeight(1.5F);
        rect(_x, _y, 20, 20, 2, 2, 2, 2);
        fill(NOIR);
        triangle(_x+5F, _y+5F, _x+5F, _y+15F, _x+15F, _y+10F);
        noStroke();
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        int identite = vehicule.ID;
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                identite = min(tous_vehicules.size()-1, identite+1);
                vehicule = tous_vehicules.get(identite);
                if (copier_CV && !coller_CV) {
                    vehicule_copie = identite;
                }
                gestion.largeur_curseur[0] = gestion.l0*vehicule.ID/(tous_vehicules.size()-1);
            }
        }
    }
}
//*********************************************************************************************
class Texte_decodeur extends Bouton {
    Texte_decodeur() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Decodeur :";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        textAlign(LEFT, CENTER);
        fill(BLANC);        
        text(texte_affiche, _x, _y+_h/2F);
    }
}
//*********************************************************************************************
class Ajoute_decodeur extends Bouton {
    Ajoute_decodeur() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Ajouter";
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                effacer_les_boutons();
                ajouter_decodeur         = true;
                gestion.one_shot         = true;
                gestion.fabricant_choisi = ".";
                gestion.famille_choisie  = ".";
                gestion.modele_choisi    = ".";
                gestion.ligne_fabricant  = -1;
                gestion.ligne_famille    = -1;
                gestion.ligne_modele     = -1;
                //----------- sauvegarde préalable -----------
                for (int i = 1; i < 201; i++) {
                    vehicule.sauve_CV[i] = vehicule.CV[i];
                }
            }
        }        
    }
}
//*********************************************************************************************
class MaJ_decodeur extends Bouton {
    MaJ_decodeur() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Mettre à jour";
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                if (!vehicule.fabricant.equals("Inconnu")) {
                    effacer_les_boutons();
                    maj_decodeur          = true;
                    gestion.one_shot      = true;
                    gestion.ligne_modele  = 0;
                    groupe = groupes[2];
                    groupe.choix_bouton_decodeur();
                    if (gestion.one_shot) {
                        gestion.fabricant_choisi = vehicule.fabricant;
                        gestion.famille_choisie  = vehicule.famille;
                        for (String mod0 : tous_modeles) {
                            int mod = mod0.indexOf("//");
                            if (mod0.substring(0, mod).equals(gestion.famille_choisie)) {
                                for (Decodeur dec0 : tous_decodeurs) {
                                    if (dec0 != null && dec0.nom_modele.equals(mod0)) {
                                        gestion.modele_choisi   = mod0;
                                        gestion.decodeur_choisi = dec0;
                                    }
                                }                        
                            }
                        }
                        for (String mod0 : tous_modeles) {
                            int mod = mod0.indexOf("//");
                            if (mod0.substring(0, mod).equals(gestion.famille_choisie)) {
                                tous_onglets.clear();
                                int nb_onglets = gestion.decodeur_choisi.Onglets.length;
                                for (int i = 0; i < nb_onglets ; i++) {
                                    tous_onglets.add(gestion.decodeur_choisi.Onglets[i]);
                                }
                            }
                        }
                        for (Onglet ong0 : tous_onglets) {
                            ong0.maj_curseurs();
                        }
                        //----------- sauvegarde préalable -----------
                        for (int i = 1; i < 201; i++) {
                            vehicule.sauve_CV[i] = vehicule.CV[i];
                        }
                    }
                }
            }
        }        
    }
}
//*********************************************************************************************
class Retirer_decodeur extends Bouton {
    Retirer_decodeur() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Retirer";
        texte_confirmation = "Retirer le décodeur efface aussi tous les CV. Confirmez-vous ?";
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (OK) {
            //----------- effacement des CV -----------
            for (int i = 1; i < 201; i++) {
                vehicule.CV[i] = -1;
            }
            vehicule.fabricant = "Inconnu";
            vehicule.famille   = "Inconnue";
            vehicule.modele    = "Inconnu";
            vehicule.date      = "";
            sauver_et_sortir   = true;
            groupe_bouton      = -1;
            ordre_bouton       = -1;
            confirmation       = false;
            OK                 = false;
            effacer_les_boutons();
            choix_du_vehicule  = true;
        } else {
            if (annule) {
                confirmation      = false;
                annule            = false;
                groupe_bouton     = -1;
                ordre_bouton      = -1;
                effacer_les_boutons();
                choix_du_vehicule = true;
            } else {
                if (mouseX > x && mouseX < x+l
                 && mouseY > y && mouseY < y+h) {
                    if (top == 1) {
                        effacer_les_boutons();
                        confirmation  = true;
                        groupe_bouton = 0;                                                                                    //  "groupe_bouton", c'est le groupe dans lequel est le bouton de départ
                        ordre_bouton  = 3;                                                                                    //  "ordre_bouton", c'est l'ordre du bouton de départ dans le groupe de boutrons du départ
                    }
                }
            }
        }        
    }
}
//*********************************************************************************************
class Action_CV extends Bouton {
    Action_CV() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Action sur les CV :";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        textAlign(CENTER, CENTER);
        fill(BLANC);       
        text(texte_affiche, _x+_l/2, _y+_h/2F);
    }
}
//*********************************************************************************************
class Copier_CV extends Bouton {
    Copier_CV() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Copier";
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                vehicule_copie = vehicule.ID;
                copier_CV      = true;
            }
        }       
    }
}
//*********************************************************************************************
class Coller_CV extends Bouton {
    Coller_CV() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Coller";
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                coller_CV  = true;
            }
        }        
    }
}
//*********************************************************************************************
class Filtre extends Bouton {
    Filtre() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Filtrer par :";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        textAlign(CENTER, CENTER);        
        fill(BLANC);
        text(texte_affiche, _x+_l/2, _y+_h/2F);
    }
}
//*********************************************************************************************
class Echelle extends Bouton {
    Echelle() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Echelle";
        effacer_choix();
        titre_choix    = "Filtrer par échelle";
        texte_choix[0] = "HO";
        texte_choix[1] = "HOe";
        texte_choix[2] = "HOm";
        texte_choix[3] = "N";
        texte_choix[4] = "0";
        compte_choix();
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        if (couleur_echelle) {
            image(gros_vert, _x, _y, _l, _h);
        } else {
            image(gros_bleu, _x, _y, _l, _h);
        }
        textAlign(CENTER, CENTER);       
        fill(NOIR);
        text(texte_affiche, _x+_l/2, _y+_h/2F);
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                choix[0]          = true;
                choix_du_vehicule = true;
            }
        }
    }
}
//*********************************************************************************************
class Bouton_moteur extends Bouton {
    Bouton_moteur() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Moteur";
        effacer_choix();
        titre_choix    = "Filtrer par type de matériel";
        texte_choix[0] = "Moteur";
        texte_choix[1] = "Remorqué";
        compte_choix();
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        if (couleur_moteur) {
            image(gros_vert, _x, _y, _l, _h);
        } else {
            image(gros_bleu, _x, _y, _l, _h);
        }
        textAlign(CENTER, CENTER);
        fill(NOIR);
        text(texte_affiche, _x+_l/2, _y+_h/2F);
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                choix[1]       = true;
            }
        }        
    }
}
//*********************************************************************************************
class DCC extends Bouton {
    DCC() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = " DCC ";
        effacer_choix();
        titre_choix    = "Filtrer par décodeur";
        texte_choix[0] = "DCC";
        texte_choix[1] = "Analogique";
        compte_choix();
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        if (couleur_DCC) {
            image(gros_vert, _x, _y, _l, _h);
        } else {
            image(gros_bleu, _x, _y, _l, _h);
        }
        textAlign(CENTER, CENTER);
        fill(NOIR);
        text(texte_affiche, _x+_l/2, _y+_h/2F);
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                choix[2]       = true;
            }
        }        
    }
}
//*********************************************************************************************
class Marque extends Bouton {
    Marque() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Marque loco";
        effacer_choix();
        titre_choix    = "Filtrer par marque";
        int marques_size = toutes_marques.size();
        for (int i = 0; i < marques_size; i++) {
            texte_choix[i] = toutes_marques.get(i);
        }
        compte_choix();
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        if (couleur_marque) {
            image(gros_vert, _x, _y, _l, _h);
        } else {
            image(gros_bleu, _x, _y, _l, _h);
        }
        textAlign(CENTER, CENTER);
        fill(NOIR);
        text(texte_affiche, _x+_l/2, _y+_h/2F);
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                choix[3]          = true;
                choix_du_vehicule = true;
            }
        }        
    }
}
//*********************************************************************************************
class Bouton_Proprietaire extends Bouton {
    Bouton_Proprietaire() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Propriétaire";
        effacer_choix();
        titre_choix    = "Filtrer par propriétaire";
        int prop_size = tous_proprietaires.size();
        for (int i = 0; i < prop_size; i++) {
            texte_choix[i] = tous_proprietaires.get(i).prop;
        }
        compte_choix();
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        if (couleur_proprietaire) {
            image(gros_vert, _x, _y, _l, _h);
        } else {
            image(gros_bleu, _x, _y, _l, _h);
        }
        textAlign(CENTER, CENTER);
        fill(NOIR);
        text(texte_affiche, _x+_l/2, _y+_h/2F);
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                choix[4]          = true;
                choix_du_vehicule = true;
            }
        }        
    }
}
//*********************************************************************************************
class Effacer_filtres extends Bouton {
    Effacer_filtres() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Effacer filtres";
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                int compte_vehicules = -1;
                tous_vehicules_filtres.clear();
                tous_vehicules.clear();
                for (Vehicule veh0 : tous_vehicules_complet) {
                    compte_vehicules++;
                    veh0.ID = compte_vehicules;
                    tous_vehicules_filtres.add(veh0);
                    tous_vehicules.add(veh0);
                }
                vehicule = tous_vehicules.get(0);
                effacer_les_boutons();
                choix_du_vehicule = true;
            }
        }        
    }
}
//*********************************************************************************************
class Faire_copie extends Bouton {
    Faire_copie() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Réaliser la copie effective";
        texte_confirmation = "Les CV existants seront écrasés. Confirmez-vous ?";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        if (vehicule.fabricant != "Inconnu") {
            imageMode(CORNER);
            image(gros_bleu, _x, _y, _l, _h);        
            textAlign(CENTER, CENTER);
            fill(NOIR);
            text(texte_affiche, _x+_l/2, _y+_h/2F);
            x = _x; y = _y; l = _l; h = _h;
        }
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (OK) {
            if (vehicule.fabricant != "Inconnu") {
                for (int i = 1; i < 201; i++) {
                    vehicule.CV[i] = tous_vehicules.get(vehicule_copie).CV[i];
                }
                groupe_bouton      = -1;
                ordre_bouton       = -1;
                confirmation       = false;
                OK                 = false;
                effacer_les_boutons();
                choix_du_vehicule  = true;
                sauver_et_sortir   = true;
            }
        } else {
            if (annule) {
                confirmation      = false;
                annule            = false;
                groupe_bouton     = -1;
                ordre_bouton      = -1;
                effacer_les_boutons();
                choix_du_vehicule = true;
            } else {
                if (mouseX > x && mouseX < x+l
                 && mouseY > y && mouseY < y+h) {
                    if (top == 1) {
                        effacer_les_boutons();
                        groupe_bouton = 1;                                                                                    //  "groupe_bouton", c'est le groupe dans lequel est le bouton de départ
                        ordre_bouton  = 0;                                                                                    //  "ordre_bouton", c'est l'ordre du bouton de départ dans le groupe de boutrons du départ
                        confirmation  = true;
                    }
                }
            }
        }
    }
}
//*********************************************************************************************
class Sortir_copie extends Bouton {
    Sortir_copie() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Sortir de la copie sans rien faire";
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                copier_CV      = false;
                coller_CV      = false;
                choix_vehicule = true;
                vehicule_copie = vehicule.ID;
            }
        }        
    }
}
//*********************************************************************************************
class Maj_retour extends Bouton {
    Maj_retour() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = " Mettre à jour et sortir ";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        if (!dessine_les_fabricants) {
            imageMode(CORNER);
            image(gros_bleu, _x, _y, _l, _h);        
            textAlign(CENTER, CENTER);
            fill(NOIR);
            text(texte_affiche, _x+_l/2, _y+_h/2F);
            x = _x; y = _y; l = _l; h = _h;
        }
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (!dessine_les_fabricants) {
            if (mouseX > x && mouseX < x+l
             && mouseY > y && mouseY < y+h) {
                if (top == 1) {
                    effacer_les_boutons();
                    maj_date();
                    vehicule.date     = date;
                    sauver_et_sortir  = true;
                    gestion.one_shot  = false;
                    choix_du_vehicule = true;
                }
            }
        }
    }
}
//*********************************************************************************************
class Retour_sans_maj extends Bouton {
    Retour_sans_maj() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = " Retour aux véhicules ";
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                effacer_les_boutons();
                choix_du_vehicule = true;
                //----------- récupération de la sauvegarde préalable -----------
                for (int i = 1; i < 201; i++) {
                    vehicule.CV[i] = vehicule.sauve_CV[i];
                }               
            }
        }        
    }
}
//*********************************************************************************************
class OK extends Bouton {
    OK() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "  OK  ";
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                OK     = true;
                annule = false;
                groupe_confirmation = groupes[groupe_bouton];                                                                 //  groupe_bouton, c'est le groupe dans lequel est le bouton de départ
                groupe_confirmation.Boutons[ordre_bouton].appui_bouton();                                                     //  ordre_bouton, c'est l'ordre du bouton de départ dans le groupe de boutrons du départ
                //--------------- onglet adresse ----------------
                if (groupe.numero_groupe == 6) {
                    vehicule.CV[29] = CV29;
                }
            }
        }        
    }
}
//*********************************************************************************************
class Annule extends Bouton {
    Annule() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "  Annuler et sortir  ";
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                annule = true;
                OK     = false;
                groupe_confirmation = groupes[groupe_bouton];                                                                 //  groupe_bouton, c'est le groupe dans lequel est le bouton de départ
                groupe_confirmation.Boutons[ordre_bouton].appui_bouton();                                                     //  ordre_bouton, c'est l'ordre du bouton de départ dans le groupe de boutrons du départ
            }
        }        
    }
}
//*********************************************************************************************
class Valeur_CV29_enregistree extends Bouton {
    Valeur_CV29_enregistree() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Valeur du CV29 enregistrée dans le décodeur";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle(x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        groupe.Boutons[0].CV29_bin_dec();
        if (texte_choisi == null) {
            imageMode(CORNER);
            image(affiche_bleu, x+130F, y+5F, l, h);
            textAlign(LEFT, CENTER);       
            fill(NOIR);
            text(str(vehicule.CV[29]), x+270F, y+1F+h/2F);
        }
    }
}
//*********************************************************************************************
class Sens_normal extends Bouton {
    Sens_normal() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Sens normal/sens inverse";
        effacer_choix();
        titre_choix    = "Voulez-vous inverser le sens de circulation ?";
        texte_choix[0] = "(CV29 bit 0 = 0)  Sens normal";
        texte_choix[1] = "(CV29 bit 0 = 1)  Sens inverse";
        compte_choix();
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x0+l0
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                groupe.Boutons[1].choix[1] = true;
            }
        }
    }
}
//*********************************************************************************************
class Nb_crans extends Bouton {
    Nb_crans() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Nombre de crans de vitesse";
        effacer_choix();
        titre_choix    = "Choisissez le nombre de crans de vitesse désiré";
        texte_choix[0] = "(CV29 bit 1 = 0)  14/28 crans";
        texte_choix[1] = "(CV29 bit 1 = 1)  128 crans (recommandé)";
        compte_choix();
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x0+l0
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                groupe.Boutons[2].choix[2] = true;
            } else {
                gestion.dessine_rectangle_inverse(x0+l0+20F, y, 330F, 90F);
                textAlign(LEFT, TOP);
                fill(BLANC);
                text("S'il y a 14 crans de vitesse, l'inversion"
                +char(10)+"des phares dépend du sens de circulation."
                +char(10)+"S'il y a 28 ou 128 crans, l'inversion"
                +char(10)+"des phares est gérée par les fonctions.", x0+l0+30F, y+5F);
            }
        }
    }
}
//*********************************************************************************************
class Analogique extends Bouton {
    Analogique() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Gestion d'une source d'alimentation non DCC";
        effacer_choix();
        titre_choix    = "Voulez-vous pouvoir rouler avec une source d'alimentation non DCC ?";
        texte_choix[0] = "(CV29 bit 2 = 0)  Interdire le changement de source";
        texte_choix[1] = "(CV29 bit 2 = 1)  Autoriser le changement de source";
        compte_choix();
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x0+l0
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                groupe.Boutons[3].choix[3] = true;
            }
        }
    }
}
//*********************************************************************************************
class Bouton_railcom extends Bouton {
    Bouton_railcom() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Utilisation de Railcom";
        effacer_choix();
        titre_choix    = "Voulez-vous utiliser Railcom ?";
        texte_choix[0] = "(CV29 bit 3 = 0)  Sans Railcom";
        texte_choix[1] = "(CV29 bit 3 = 1)  Avec Railcom";
        compte_choix();
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x0+l0
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                groupe.Boutons[4].choix[4] = true;
            }
        }
    }
}
//*********************************************************************************************
class Table_vitesse extends Bouton {
    Table_vitesse() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Nombre de points de la courbe de vitesse";
        effacer_choix();
        titre_choix    = "Quel type de gestion de vitesse voulez-vous ?";
        texte_choix[0] = "(CV29 bit 4 = 0)  Gestion à  3 points";
        texte_choix[1] = "(CV29 bit 4 = 1)  Gestion à 28 points";
        compte_choix();
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x0+l0
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                groupe.Boutons[5].choix[5] = true;
            }
        }
    }
}
//*********************************************************************************************
class Adresse_courte extends Bouton {
    Adresse_courte() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Adresse courte (1 à 99) ou étendue (128 à 9983)";
        effacer_choix();
        titre_choix    = "Quelle longueur d'adresse voulez-vous ?";
        texte_choix[0] = "(CV29 bit 5 = 0)  Adresse courte";
        texte_choix[1] = "(CV29 bit 5 = 1)  Adresse étendue";
        compte_choix();
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x0+l0
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                //--------------- onglet adresse ----------------
                if (groupe.numero_groupe == 6) {
                    groupe.Boutons[0].choix[0] = true;
                } else {
                    //------------- onglet configutation ------------
                    if (groupe.numero_groupe == 7) {
                        groupe.Boutons[6].choix[6] = true;
                    }
                }
            }
        }
    }
}
//*********************************************************************************************
class CV29_bit6 extends Bouton {
    CV29_bit6() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Réservé pour une utilisation future par la NMRA";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle(x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        if (texte_choisi == null) {
            textAlign(LEFT, CENTER);       
            fill(NOIR);
            text("(CV29 bit 6 = 0)", x, y+1F+h/2F);
        }
    }
}
//*********************************************************************************************
class CV29_bit7 extends Bouton {
    CV29_bit7() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Réservé pour une utilisation future par la NMRA";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle(x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        if (texte_choisi == null) {
            textAlign(LEFT, CENTER);       
            fill(NOIR);
            text("(CV29 bit 7 = 0)", x, y+1F+h/2F);
        }
    }
}
//*********************************************************************************************
class Valeur_CV29_modifiee extends Bouton {
    Valeur_CV29_modifiee() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Valeur décimale du CV29 tenant compte des sélections faites";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle(x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        groupe.Boutons[0].CV29_bin_dec();
        if (texte_choisi == null) {
            imageMode(CORNER);
            if (CV29 == vehicule.CV[29]) {
                image(affiche_bleu, x+130F, y+5F, l, h);
            } else {
                image(affiche_vert, x+130F, y+5F, l, h);
            }
            textAlign(LEFT, CENTER);       
            fill(NOIR);
            text(str(CV29), x+270F, y+1F+h/2F);
        }
    }
}
//*********************************************************************************************
class Adresse extends Bouton {
    Adresse() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche      = "Entrez une adresse au clavier puis faites ENTREE";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle(x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        imageMode(CORNER);
        image(affiche_bleu, x+130F, y+5F, l, h);
        fill(NOIR);
        textAlign(CENTER, CENTER);
        if (adresse_saisie == -1) {
            image(affiche_bleu, x+130F, y+5F, l, h);
            text(texte_saisi, x+270F, y+1F+h/2F);
        } else {
            image(affiche_vert, x+130F, y+5F, l, h);
            text(adresse_saisie, x+270F, y+1F+h/2F);
        }
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x0+l0
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                //--------------- onglet adresse ----------------
                if (groupe.numero_groupe == 6) {
                    groupe.Boutons[0].choix[0] = true;
                }
            }
        }
    }
}
//*********************************************************************************************
class Adresse_actuelle extends Bouton {
    Adresse_actuelle() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Adresse actuelle";
    }
    //-------------------------- dessine_bouton_bleu() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle(x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        imageMode(CORNER);
        int CV29_bit5 = int(binary(vehicule.CV[29], 8).substring(7-5, 7-5+1));
        image(affiche_bleu, x+130F, y+5F, l, h);
        fill(NOIR);
        textAlign(CENTER, CENTER);       
        if (CV29_bit5 == 0) {
            text(vehicule.CV[1], x+270F, y+1F+h/2F);
        } else {
            text((vehicule.CV[17]-192)*256+vehicule.CV[18], x+270F, y+1F+h/2F);
        }
    }
}
//*********************************************************************************************
class CV1 extends Bouton {
    CV1() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Valeur du CV1";
    }
    //-------------------------- dessine_bouton_bleu() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle(x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        imageMode(CORNER);
        image(affiche_bleu, x+130F, y+5F, l, h);
        fill(NOIR);
        textAlign(LEFT, CENTER);       
        text("(CV1)             ", x, y+1F+h/2F);
        textAlign(CENTER, CENTER);       
        text(vehicule.CV[1], x+270F, y+1F+h/2F);
    }
    //-------------------------- dessine_bouton_bleu_modifie() -------------------------------
    void dessine_bouton_bleu_modifie(boolean _vert) {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle(x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        imageMode(CORNER);
        image(affiche_vert, x+130F, y+5F, l, h);
        fill(NOIR);
        textAlign(LEFT, CENTER);       
        text("(CV1)             ", x, y+1F+h/2F);
        textAlign(CENTER, CENTER);
        text(str(adresse_saisie), x+270F, y+1F+h/2F);
    }
}
//*********************************************************************************************
class CV17 extends Bouton {
    CV17() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Adresse étendue (128 à 9983) bits de poids fort";
    }
    //-------------------------- dessine_bouton_bleu() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle(x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        imageMode(CORNER);
        image(affiche_bleu, x+130F, y+5F, l, h);
        fill(NOIR);
        textAlign(LEFT, CENTER);       
        text("(CV17)            ", x, y+1F+h/2F);
        textAlign(CENTER, CENTER);       
        text(vehicule.CV[17], x+270F, y+1F+h/2F);
    }
    //-------------------------- dessine_bouton_bleu_modifie() -------------------------------
    void dessine_bouton_bleu_modifie(boolean _vert) {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle(x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        imageMode(CORNER);
        image(affiche_vert, x+130F, y+5F, l, h);
        fill(NOIR);
        textAlign(LEFT, CENTER);       
        text("(CV17)            ", x, y+1F+h/2F);
        textAlign(CENTER, CENTER);
        text(str(CV17), x+270F, y+1F+h/2F);
    }
}
//*********************************************************************************************
class CV18 extends Bouton {
    CV18() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Adresse étendue (128 à 9983) bits de poids faible";
    }
    //-------------------------- dessine_bouton_bleu() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle(x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        imageMode(CORNER);
        image(affiche_bleu, x+130F, y+5F, l, h);
        fill(NOIR);
        textAlign(LEFT, CENTER);       
        text("(CV18)            ", x, y+1F+h/2F);
        textAlign(CENTER, CENTER);       
        text(vehicule.CV[18], x+270F, y+1F+h/2F);
    }
    //-------------------------- dessine_bouton_bleu_modifie() -------------------------------
    void dessine_bouton_bleu_modifie(boolean _vert) {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle(x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        imageMode(CORNER);
        image(affiche_vert, x+130F, y+5F, l, h);
        fill(NOIR);
        textAlign(LEFT, CENTER);       
        text("(CV18)            ", x, y+1F+h/2F);
        textAlign(CENTER, CENTER);
        text(str(CV18), x+270F, y+1F+h/2F);
    }
}
//*********************************************************************************************
class Vapeur extends Bouton {
    Vapeur() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Loco vapeur";
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                onglet.parametre = 0;
            }
        }       
    }
}
//*********************************************************************************************
class Electrique_diesel extends Bouton {
    Electrique_diesel() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Loco électrique/diesel";
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                onglet.parametre = 1;
            }
        }       
    }
}
//*********************************************************************************************
class Boutons_libres extends Bouton {
    Boutons_libres() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Boutons libres";
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                onglet.parametre = 2;
            }
        }       
    }
}
//*********************************************************************************************
class Modif_proprietaire extends Bouton {
    Modif_proprietaire() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche      = "Entrez le n° du proprietaire au clavier puis faites ENTREE";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle(x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        fill(NOIR);
        text("(CV106)", x+60F, y+20F);
        imageMode(CORNER);
        image(affiche_bleu, x+130F, y+5F, l, h);
        fill(NOIR);
        textAlign(CENTER, CENTER);
        if (numero_saisi == -1) {
            image(affiche_bleu, x+130F, y+5F, l, h);
            if (texte_saisi != "") {
                text(texte_saisi, x0+l0-l/2F-10F/*270F*/, y+1F+h/2F);
            } else {
                text(str(vehicule.CV[106]), x0+l0-l/2F-10F/*270F*/, y+1F+h/2F);
            }
        } else {
            if (numero_saisi == vehicule.CV[106]) {
                image(affiche_bleu, x+130F, y+5F, l, h);
            } else {
                image(affiche_vert, x+130F, y+5F, l, h);
            }
            text(numero_saisi, x0+l0-l/2F-10F/*270F*/, y+1F+h/2F);
        }
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x0+l0
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
            }
        }
    }
}
//*********************************************************************************************
class Longueur extends Bouton {
    Longueur() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Longueur du décodeur";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle(x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        if (texte_choisi == null) {
            textAlign(LEFT, CENTER);       
            fill(NOIR);
            text("(valeur fabricant en mm)", x-120F, y+1F+h/2F);
            imageMode(CORNER);
            image(affiche_bleu, x+130F, y+5F, l, h);
            fill(NOIR);
            textAlign(CENTER, CENTER);
            valeur_mm(decodeur.longueur);
            text(dixieme_mm, x0+l0-l/2F-10F/*270F*/, y+1F+h/2F);
        }
    }
}
//*********************************************************************************************
class Largeur extends Bouton {
    Largeur() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Largeur du décodeur";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle(x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        if (texte_choisi == null) {
            textAlign(LEFT, CENTER);       
            fill(NOIR);
            text("(valeur fabricant en mm)", x-120F, y+1F+h/2F);
            imageMode(CORNER);
            image(affiche_bleu, x+130F, y+5F, l, h);
            fill(NOIR);
            textAlign(CENTER, CENTER);
            valeur_mm(decodeur.largeur);
            text(dixieme_mm, x0+l0-l/2F-10F/*270F*/, y+1F+h/2F);
        }
    }
}
//*********************************************************************************************
class Hauteur extends Bouton {
    Hauteur() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Hauteur du décodeur";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle(x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        if (texte_choisi == null) {
            textAlign(LEFT, CENTER);       
            fill(NOIR);
            text("(valeur fabricant en mm)", x-120F, y+1F+h/2F);
            imageMode(CORNER);
            image(affiche_bleu, x+130F, y+5F, l, h);
            fill(NOIR);
            textAlign(CENTER, CENTER);
            valeur_mm(decodeur.hauteur);
            text(dixieme_mm, x0+l0-l/2F-10F/*270F*/, y+1F+h/2F);
        }
    }
}
//*********************************************************************************************
class Numero_fabricant extends Bouton {
    Numero_fabricant() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Numéro du fabricant du décodeur";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle(x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        if (texte_choisi == null) {
            textAlign(LEFT, CENTER);       
            fill(NOIR);
            text("(valeur NMRA dans le CV8)", x-120F, y+1F+h/2F);
            imageMode(CORNER);
            image(affiche_bleu, x+130F, y+5F, l, h);
            fill(NOIR);
            textAlign(CENTER, CENTER);
            text(str(decodeur.numero_fabricant), x0+l0-l/2F-10F/*270F*/, y+1F+h/2F);
        }
    }
}
//*********************************************************************************************
class Numero_version extends Bouton {
    Numero_version() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche  = "Numéro de version du décodeur";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton_bleu() {
        x0 = groupe.x0; x = groupe.x; y = groupe.y; l = groupe.l; h = groupe.h; l0 = groupe.l0; h0 = groupe.h0;
        gestion.dessine_rectangle(x0, y, l0, h0);
        textFont(Courier14);
        textAlign(LEFT);
        fill(BLANC);
        text(texte_affiche, x0+5F, y+20F);
        if (texte_choisi == null) {
            textAlign(LEFT, CENTER);       
            fill(NOIR);
            text("(valeur fabricant dans le CV7)", x-120F, y+1F+h/2F);
            imageMode(CORNER);
            image(affiche_bleu, x+130F, y+5F, l, h);
            fill(NOIR);
            textAlign(CENTER, CENTER);
            text(str(decodeur.numero_version), x0+l0-l/2F-10F/*270F*/, y+1F+h/2F);
        }
    }
}
//*********************************************************************************************
class Valeurs_usine extends Bouton {
    Valeurs_usine() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Retour des CV aux valeurs usine";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        if (valeurs_usine) {
            image(gros_vert, _x, _y, _l, _h);
        } else {
            image(gros_bleu, _x, _y, _l, _h);
        }
        textAlign(CENTER, CENTER);
        fill(NOIR);        
        text(texte_affiche, _x+_l/2, _y+_h/2F);
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                valeurs_usine = true;
            } else {
                String texte_info =  "Si des mises à jour récentes"
                           +char(10)+"étaient cause de dysfonctionnements,"
                           +char(10)+"le retour des principaux CV"
                           +char(10)+"aux valeurs usine PEUT permettre"
                           +char(10)+"de retrouver le fonctionnement"
                           +char(10)+"nominal de la loco."
                  +char(10)+char(10)+"Il s'agit ICI d'un RESET 'LIGHT'."
                           +char(10)+"On recopie simplement les valeurs usine de ce décodeur.";
                gestion.dessine_rectangle_inverse((1366F-500)/2F, (768F-300F)/2F, 500F, 300F);
                textFont(Courier14);
                textAlign(CENTER, CENTER);
                text(texte_info, width/2F, height/2F);              
            }
        }       
    }
}
//*********************************************************************************************
class Master_reset extends Bouton {
    Master_reset() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Master reset";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        if (master_reset) {
            image(gros_vert, _x, _y, _l, _h);
        } else {
            image(gros_bleu, _x, _y, _l, _h);
        }
        textAlign(CENTER, CENTER);
        fill(NOIR);        
        text(texte_affiche, _x+_l/2, _y+_h/2F);
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                if (gestion.modele_choisi.equals("Zimo/MX617//MX617 Version Fleischmann")) {
                    master_reset = true;
                }
            } else {
                String texte_info  = "Si le décodeur est définitivement bloqué,"
                           +char(10)+"il faut recourir à un reset complet"
                           +char(10)+"du décodeur suivant une procédure"
                           +char(10)+"tout à fait spécifique."
                  +char(10)+char(10)+"Il s'agit ICI d'un MASTER RESET";
                gestion.dessine_rectangle_inverse((1366F-500)/2F, (768F-300F)/2F, 500F, 300F);
                textFont(Courier14);
                textAlign(CENTER, CENTER);
                text(texte_info, width/2F, height/2F);              
            }
        }       
    }
}
//*********************************************************************************************
class Bouton_fonction extends Bouton {
    Bouton_fonction() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        if (valide) {
            image(validation, _x, _y, _l, _h);
        } else {
            image(validationV, _x, _y, _l, _h);
        }
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                valide = !valide;
            }
        }        
    }
}
//*********************************************************************************************
class Fonctions_par_defaut extends Bouton {
    Fonctions_par_defaut() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Valeurs par défaut";
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                groupe.fonctions_par_defaut();
            }
        }       
    }
}
//*********************************************************************************************
class Fonctions_decodeur extends Bouton {
    Fonctions_decodeur() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Valeurs déjà dans"+char(10)+"le décodeur";
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                groupe.fonctions_decodeur();
            }
        }       
    }
}
//*********************************************************************************************
class Selection_CV extends Bouton {
    Selection_CV() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        if (valide) {
            image(validationVG, _x, _y, _l, _h);
        }
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                appui_CV = int(10F*((y-107F)/45F)+((x-11F)/135F)+1.5F);        // 1.5 = +1 car on démarre à 1 et +0.5 pour l'arrondi
                if (!transfert_fich_dec && !transfert_dec_fich) {
                    port.write("<R "+str(appui_CV)+" 1"+str(appui_CV)+" 1"+str(appui_CV)+">");
                    debut_comptage = millis();
                }
            } else {
                valide = true;
            }
        } else {
            valide = false;
        }
    }
}
//*********************************************************************************************
class Fichier_decodeur extends Bouton {
    Fichier_decodeur() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Transfert Fichier --> Décodeur";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        if (transfert_fich_dec) {
            image(gros_vert, _x, _y, _l, _h);
        } else {
            image(gros_bleu, _x, _y, _l, _h);
        }
        textAlign(CENTER, CENTER);       
        fill(NOIR);
        text(texte_affiche, _x+_l/2, _y+_h/2F);
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                transfert_fich_dec = true;
                appui_CV = 0;
            } else {
                if (!transfert_fich_dec) {
                    String texte_info  = "Normalement, la valeur du CV dans le décodeur"
                               +char(10)+"est la même que celle dans le fichier."
                               +char(10)+"Les deux sont donc sur fond vert."
                      +char(10)+char(10)+"En cas d'écart, les valeurs apparaissent sur fond bleu."
                      +char(10)+char(10)+"Pour rectifier, appuyez d'abord sur LE BON BOUTON,"                           
                               +char(10)+"puis cliquez dans la case à rectifier.";
                    gestion.dessine_rectangle_inverse((1366F-500)/2F, (768F-300F)/2F, 500F, 300F);
                    textFont(Courier14);
                    textAlign(CENTER, CENTER);
                    text(texte_info, width/2F, height/2F);
                }
            }
        }       
    }
}
//*********************************************************************************************
class Decodeur_fichier extends Bouton {
    Decodeur_fichier() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Transfert Décodeur --> Fichier";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        if (transfert_dec_fich) {
            image(gros_vert, _x, _y, _l, _h);
        } else {
            image(gros_bleu, _x, _y, _l, _h);
        }
        textAlign(CENTER, CENTER);       
        fill(NOIR);
        text(texte_affiche, _x+_l/2, _y+_h/2F);
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                transfert_dec_fich = true;
                appui_CV = 0;
            } else {
                if (!transfert_dec_fich) {
                    String texte_info  = "Normalement, la valeur du CV dans le décodeur"
                               +char(10)+"est la même que celle dans le fichier."
                               +char(10)+"Les deux sont donc sur fond vert."
                      +char(10)+char(10)+"En cas d'écart, les valeurs apparaissent sur fond bleu."
                      +char(10)+char(10)+"Pour rectifier, appuyez d'abord sur LE BON BOUTON,"                           
                               +char(10)+"puis cliquez dans la case à rectifier.";
                    gestion.dessine_rectangle_inverse((1366F-500)/2F, (768F-300F)/2F, 500F, 300F);
                    textFont(Courier14);
                    textAlign(CENTER, CENTER);
                    text(texte_info, width/2F, height/2F);
                }
            }
        }       
    }
}
//*********************************************************************************************
class Validation_CV extends Bouton {
    Validation_CV() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Validez les choix pour cet onglet";
    }
    //-------------------------- dessine_bouton() -------------------------------
    void dessine_bouton(float _x, float _y, float _l, float _h) {
        imageMode(CORNER);
        if (appui_validation) {
            image(gros_vert, _x, _y, _l, _h);
        } else {
            image(gros_bleu, _x, _y, _l, _h);
        }
        textAlign(CENTER, CENTER);       
        fill(NOIR);
        text(texte_affiche, _x+_l/2, _y+_h/2F);
        x = _x; y = _y; l = _l; h = _h;
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                if (groupe1.numero_groupe == 100) {
                    //------------- onglet fiche --------------
                    if (groupe.numero_groupe == 5) {                                                                          //  Boutons_onglet_fiche
                        if (valeurs_usine || master_reset) {
                            appui_validation = true;
                        } else {
                            bouton = groupe.Boutons[0];                                                                       //  Modif_proprietaire()
                            vehicule.CV[106] = bouton.numero_saisi;
                            ecrire_CV(106, vehicule.CV[106]);
                        }
                    }
                    //------------- onglet configutation ------------
                    if (groupe.numero_groupe == 7) {                                                                          //  Boutons_onglet_configuration
                        vehicule.CV[29] = CV29;
                        appui_validation = true;
                        ecrire_CV(29, vehicule.CV[29]);
                    }
                    //------------- onglet adresse ------------
                    if (groupe.numero_groupe == 6) {                                                                          //  Boutons_onglet_adresse
                        bouton = groupe.Boutons[5];                                                                           //  Adresse()
                        texte_ecrire = "";
                        appui_validation = true;
                        if (bouton.adresse_saisie > 0 && bouton.adresse_saisie < 100) {
                            vehicule.CV[1] = bouton.adresse_saisie;
                        } else {
                            if (bouton.adresse_saisie > 127 && bouton.adresse_saisie < 9984) {
                                bouton = groupe.Boutons[3];                                                                   //  CV17()
                                vehicule.CV[17] = bouton.CV17;
                                bouton = groupe.Boutons[4];                                                                   //  CV18()
                                vehicule.CV[18] = bouton.CV18;
                            }
                        }
                        bouton = groupe.Boutons[1];                                                                           //  Adresse_courte()
                        if (bouton.modif_CV29 != 0) { 
                            vehicule.CV[29] = CV29+32*bouton.modif_CV29;
                        }
                    }
                    //------------- onglet moteur ------------
                    if (groupe.numero_groupe == 8) {                                                                          //  Boutons_onglet_moteur
                        texte_ecrire = "";
                        appui_validation = true;
                        vehicule.CV[3] = int(onglet.hauteur_curseur[0]*70F/255F+.5);
                        vehicule.CV[4] = int(onglet.hauteur_curseur[1]*70F/255F+.5);
                    }
                    //------------- onglet controle basique de vitesse ------------
                    if (groupe.numero_groupe == 9) {                                                                          //  Boutons_onglet_controle_basique_de_vitesse
                        texte_ecrire = "";
                        appui_validation = true;
                        int CV29_bit4 = int(binary(vehicule.CV[29], 8).substring(7-4, 7-4+1));
                        if (CV29_bit4 == 1) {
                            CV29 = vehicule.CV[29]-16;
                            vehicule.CV[29] = CV29;                            
                        }
                        vehicule.CV[2] = int(onglet.hauteur_curseur[0]+.5);
                        vehicule.CV[6] = int(onglet.hauteur_curseur[1]+.5);
                        vehicule.CV[5] = int(onglet.hauteur_curseur[2]+.5);
                    }
                    //------------- onglet tableau_vitesse ------------
                    if (groupe.numero_groupe == 10) {                                                                         //  Boutons_onglet_tableau_vitesse
                        texte_ecrire = "";
                        appui_validation = true;
                        int CV29_bit4 = int(binary(vehicule.CV[29], 8).substring(7-4, 7-4+1));
                        if (CV29_bit4 == 0) {
                            CV29 = vehicule.CV[29]+16;
                            vehicule.CV[29] = CV29;                            
                        }
                        for (int i = 0; i < 28; i++) {
                            vehicule.CV[67+i] = int(onglet.hauteur_curseur[i]+.5);
                        }
                        for (int i = 30; i < 35; i++) {
                            vehicule.p[i-30] = int(onglet.hauteur_curseur[i]+.5);
                        }
                    }
                    //------------- onglet fonctions -----------------
                    if (groupe.numero_groupe == 11) {                                                                         //  Boutons_onglet_carte_fonctions
                        texte_ecrire = "";
                        appui_validation = true;
                        for (int i = 33; i < 47; i++) {
                            vehicule.CV[i] = CV[i-33];
                        }
                    }
                    top = 2;
                    maj_date();
                    vehicule.date    = date;
                    sauve_table_Materiel();
                    gestion.one_shot = false;
                }
            } else {
                //-------------------- avant propriétaire ---------------
                if (groupe.numero_groupe == 5) {                                                                              //  Boutons_onglet_fiche
                    bouton = groupe.Boutons[0];
                    if ((numero_saisi == vehicule.CV[106]) && !valeurs_usine && !appui_validation) {
                        gestion.dessine_rectangle_inverse((1366F-500)/2F, (768F-300F)/2F, 500F, 300F);
                        textFont(Courier17);
                        textAlign(CENTER, CENTER);
                        text("Vous avez entré le même propriétaire", width/2F, height/2F);
                    }
                    if ((bouton.numero_saisi == -1) && !valeurs_usine && !appui_validation) {
                        gestion.dessine_rectangle_inverse((1366F-500)/2F, (768F-300F)/2F, 500F, 300F);
                        textFont(Courier17);
                        textAlign(CENTER, CENTER);
                        text("Vous n'avez pas fait 'ENTREE'", width/2F, height/2F);
                    }
                }
                //-------------------- avant adresse ---------------
                if (groupe.numero_groupe == 6) {                                                                              //  Boutons_onglet_adresse
                    bouton = groupe.Boutons[5];
                    if (bouton.adresse_saisie == -1) {
                        gestion.dessine_rectangle_inverse((1366F-500)/2F, (768F-300F)/2F, 500F, 300F);
                        textFont(Courier17);
                        textAlign(CENTER, CENTER);
                        text("Vous n'avez pas fait 'ENTREE'", width/2F, height/2F);
                    }
                }
            }
        }        
    }
}
//*********************************************************************************************
class Sortir_CV extends Bouton {
    Sortir_CV() {
        description_bouton();     
    }
    //-------------------------- description_bouton() --------------------------------
    void description_bouton() {
        texte_affiche = "Ne rien changer pour cet onglet";
    }
    //-------------------------- appui_bouton() -------------------------------------
    void appui_bouton() {
        if (mouseX > x && mouseX < x+l
         && mouseY > y && mouseY < y+h) {
            if (top == 1) {
                if (groupe1.numero_groupe == 100) {
                    //------------- onglet fiche ------------
                    if (groupe.numero_groupe == 5) {
                        bouton = groupe.Boutons[0];
                        bouton.numero_saisi = vehicule.CV[106];
                        valeurs_usine = false;
                        master_reset  = false;
                    }
                    //------------- onglet adresse ------------
                    if (groupe.numero_groupe == 6) {
                        bouton = groupe.Boutons[5];
                        bouton.adresse_saisie = -1;
                    }
                    //------------- onglet configutation ------------
                    if (groupe.numero_groupe == 7) {
                        for (int i = 1; i < 9; i++) {
                            bouton = groupe.Boutons[i];
                            bouton.texte_choisi = null;
                        }
                        groupe.choix_onglet_configuration();
                    }
                    //------------- onglet tableau vitesse ------------
                    if (groupe.numero_groupe == 10) {
                        onglet.parametre = 2;
                        onglet.maj_curseurs();
                    }
                    //------------- onglet tableau vitesse ------------
                    if (groupe.numero_groupe == 11) {
                        groupe.fonctions_decodeur();
                    }
                    gestion.one_shot = true;
                    appui_validation = false;
                    texte_saisi = "";
                    ecriture_OK = true;
                }
            }
        }        
    }
}
