/////////////////////////////////// Globales ///////////////////////////////////////////////////////////
String  Repertoire_Decoduino   = "";
String  Repertoire_Communs     = "";
PFont   Courier12;
PFont   Courier14;
PFont   Courier17;
PFont   fontUnits;
Table   Materiel;
Table   Proprietaires;
int     TAILLE_POLICE          = 14;
float   ZOOM                   = TAILLE_POLICE*130F/200F;
float   H                      = 2F*TAILLE_POLICE*170F/200F;
int     E                      = 3;
float   debut_onglet[]         = new float[25];
float   blanc[]                = new float[25];
int     NB_DECODEURS           = 50;
int     NB_GROUPES             = 50;
int     NB_CHOIX               = 50;
int     LF                     = 10;  //LineFeed
int     SUPERIEUR              = 62;  // >
boolean tables_construites     = false;
boolean aff_fabricant          = false;
boolean affiche_en_tete        = false;
boolean dans_onglets           = false;
boolean dessine_les_fabricants = false;
boolean dessine_les_familles   = false;
boolean dessine_les_modeles    = false;
boolean choix_onglet           = false;
boolean dans_curseurV          = false;
boolean dans_curseurH_vehicule = false;
boolean choix_vehicule         = false;
boolean ajouter_decodeur       = false;
boolean maj_decodeur           = false;
boolean copier_CV              = false;
boolean coller_CV              = false;
boolean bouton_moteur          = false;
boolean bouton_DCC             = false;
boolean marque_loco            = false;
boolean proprietaire           = false;
boolean compo_train            = false;
boolean choix_du_vehicule      = false;
boolean sortir_sans_sauver     = false;
boolean sauver_et_sortir       = false;
boolean confirmation           = false;
boolean OK                     = false;
boolean annule                 = false;
boolean valeurs_usine          = false;
boolean master_reset           = false;
boolean transfert_fich_dec     = false;
boolean transfert_dec_fich     = false;
int     groupe_bouton          = -1;
int     ordre_bouton           = -1;
int     ordre                  = 0;
int     vehicule_copie         = 0;
boolean couleur_echelle        = false;
boolean couleur_moteur         = false;
boolean couleur_DCC            = false;
boolean couleur_marque         = false;
boolean couleur_proprietaire   = false;
String  date                   = "";
String  texte_saisi            = "";
int     CV29                   = 0;
int     top                    = 0;
int     CV[]                   = new int[14];
int     CV_decodeur[]          = new int[121];
String  chaine_lue;
String  texte_ecrire             = "";
boolean appui_validation       = false;
String  CV_valide;
boolean ecriture_OK            = true;
int     CV106                  = 0;
double  debut_comptage         = 0;
double  fin_comptage           = 0;
int     appui_CV               = 0;
String  texte_lire             = "";
boolean cherche_arduino        = true;
boolean cherche_fichier        = true;
boolean charge_tables          = true;
int     en_cours               = 0;
String  sl[]                   = null;
String  s                      = null;
boolean saut                   = false;
int     saut1                  = 0;
boolean trouve                 = false;
//------------------------------ couleurs -------------------
int       GRIS       = #808080;
int       ROUGE      = #FF0000;
int       GRIS_FONCE = #B5B5B5;
int       BLANC      = #FFFFFF;
int       JAUNE      = #faca30;//#ffb200;//#FFFF00;
int       VERT       = #00FF00;
int       VIOLET     = #9370DB;
int       VERT_FONCE = #008000;
int       ARDOISE    = #5A5E6B;
int       BLEU       = #0000FF;
int       BLEU1      = #C8E8E8;
int       BLEU2      = #9AB3B3;
int       FOSSE      = #6E696A;
int       PONT       = #A6A6A6;
int       FOND       = #D4D4D4;
int       NOIR       = #000000;
int       AQUA       = #00FFFF;
int       OR         = #FFD900;
int       OLIVE      = #556B2F;
int       SABLE      = #F4A460;
int       POURPRE    = #BA55D3;
int       VERT_FLUO  = #7CFC00;
int       VERT6019   = #b9ceac;
int       VERT6027   = #7ebab5;
int       VERTCF0    = #00CF00;
int       FOND_TRAIN = #454545;
int       FOND_VIDE  = #C5C7C4;
int       BLEU_CLAIR = #00DCFE;
int       BRUN       = #AF804F;

Decodeur  decodeur;
Onglet    onglet;
Gestion   gestion;
Zone      zone;
Vehicule  vehicule;
Bouton    bouton;
Bouton    bouton1;
Groupe    groupe;
Groupe    groupe1;
Groupe    groupe2;
Groupe    groupe3;
Groupe    groupe_confirmation;

Groupe    groupes[]   = new Groupe[NB_GROUPES];

ArrayList<Decodeur>       tous_decodeurs         = new ArrayList<Decodeur>();
ArrayList<Onglet>         tous_onglets           = new ArrayList<Onglet>();
StringList                tous_fabricants        = new StringList();
StringList                toutes_familles        = new StringList();
StringList                tous_modeles           = new StringList();
StringList                toutes_marques         = new StringList();
ArrayList<Proprietaire>   tous_proprietaires     = new ArrayList<Proprietaire>();
ArrayList<Vehicule>       tous_vehicules_complet = new ArrayList<Vehicule>();                                                 //  liste de tous les véhicules, sans filtre
ArrayList<Vehicule>       tous_vehicules         = new ArrayList<Vehicule>();                                                 //  liste de tous les véhicules filtrés
ArrayList<Vehicule>       tous_vehicules_filtres = new ArrayList<Vehicule>();                                                 //  liste de tous les véhicules après les filtres
//--------------------- PImage ----------------------
PImage  affiche_bleu;
PImage  affiche_vert;
PImage  bouton_bleu;
PImage  fond_alu;
PImage  fond_alu1;
PImage  ecran;
PImage  curseurV;
PImage  curseurH;
PImage  gros_bleu;
PImage  gros_vert;
PImage  danger;
PImage  validation;
PImage  validationV;
PImage  validationVG;
PImage  validationB;
PImage  composition;
//--------------------------- charges_images() --------------
void charge_images() {
    affiche_bleu  = loadImage("data/Affiche bleu.png");
    affiche_vert  = loadImage("data/Affiche vert.png");
    bouton_bleu   = loadImage("data/Bouton bleu.png");    
    curseurH      = loadImage("data/CurseurH.png");
    curseurV      = loadImage("data/CurseurV.png");
    gros_bleu     = loadImage("data/Bouton bleu avec cadre.png");
    gros_vert     = loadImage("data/Bouton vert avec cadre.png");
    danger        = loadImage("data/Danger.png");
    validation    = loadImage("data/Bouton_validation30.png");
    validationV   = loadImage("data/Bouton_validation30V.png");
    validationVG  = loadImage("data/Bouton_validation30V130x40.png");
    validationB   = loadImage("data/Bouton_validation30B.png");
    composition   = loadImage("data/Train5.png");
}
//--------------------------- ecrire_CV() -----------------------------
void ecrire_CV(int _CV, int _valeur_CV) {
    for (int i = 0; i < 3; i++) {
        ecriture_OK = false;
        port.write("<W "+str(_CV)+" "+str(_valeur_CV)+" 1"+str(_CV)+" 1"+str(_CV)+">");
        delay(2000);
        chaine_lue = port.readStringUntil(SUPERIEUR).substring(2);
        texte_ecrire = "Chaîne envoyée = <W "+str(_CV)+" "+str(_valeur_CV)+" 1"+str(_CV)+" 1"+str(_CV)+">"
           +char(10)+"Chaîne lue     = "+chaine_lue;
        decoupe_reponse(chaine_lue);
        if (CV_valide != null) {
            vehicule.CV[_CV] = _valeur_CV;
            if (int(CV_valide) == int(_valeur_CV)) {
                ecriture_OK = true;
                break;
            }
        } else {
            texte_ecrire = texte_ecrire +char(10)+char(10)+"Valeur de CV mal transmise. Essai n° "+str(i+1);
        }
    }
    debut_comptage = millis();
}
//--------------------------- lire_CV() -----------------------------
void lire_CV() {
    fin_comptage = millis();
    if (fin_comptage-debut_comptage > 2000) {
        chaine_lue = port.readStringUntil(SUPERIEUR);
        chaine_lue = chaine_lue.substring(2);
        decoupe_reponse(chaine_lue);
        if (CV_valide == null) {
            CV_valide = "-1";
        }
        texte_lire = "Chaîne envoyée = <R "+str(appui_CV)+" 1"+str(appui_CV)+" 1"+str(appui_CV)+">"
           +char(10)+"Chaîne lue     = "+chaine_lue;
        appui_validation = true;
        debut_comptage = millis();
        CV_decodeur[appui_CV] = int(CV_valide);
        appui_CV = 0;
    }
}
//-------------------------- decoupe_reponse() ------------------------------
void decoupe_reponse(String _reponse) {
    int longueur = _reponse.length();
    String x1 = "";
    String x2 = "";
    String x3 = "";
    CV_valide = null;
    if (_reponse.substring(0, 1).equals("<")) {
        if (!(_reponse.substring(longueur-3, longueur-1)).equals("-1")) {
            int debut   = 3;
            int courant = 2;
            //------- cas normal -------
            for (int j = 0; j < 5; j++) {
                if ((_reponse.substring(courant, courant+1)).equals("|")) {
                    x1 = _reponse.substring(debut, courant);
                    debut = courant+2;
                    break;
                }
                courant++;
            }
            courant = courant+1;
            for (int j = 0; j < 5; j++) {
                if ((_reponse.substring(courant, courant+1)).equals("|")) {
                    x2 = _reponse.substring(debut, courant);
                    debut = courant+1;
                    break;
                }
                courant++;
            }
            courant++;
            if (x2.equals(x1)) {
                for (int j = 0; j < 5; j++) {
                    if ((_reponse.substring(courant, courant+1)).equals(" ")) {
                        x3 = _reponse.substring(debut, courant);
                        debut = courant+1;
                        break;
                    }
                    courant++;
                }
                if (x3.equals(x1)) {
                    courant++;
                    for (int j = 0; j < 5; j++) {
                        if ((_reponse.substring(courant, courant+1)).equals(">")) {
                            CV_valide = _reponse.substring(debut, courant);
                            break;
                        }
                        courant++;
                    }
                }
            }
        }
    }
}
//----------------------------- initialise_CV_decodeur() -------------------------------------
void initialise_CV_decodeur() {
    for (int i = 0; i < 121; i++) {
        CV_decodeur[i] = -2;
    }
}
