//*************************************** Groupe{} ********************************************
class Groupe {
    Bouton[] Boutons;
    
    Groupe(Bouton[] b0) {
       Boutons = b0;
    }  //  constructeur

    float   x0               = 0F;
    float   x                = 0F;
    float   y                = 0F;
    float   l                = 0F;
    float   h                = 0F;
    float   l0               = 0F;
    float   h0               = 0F;
    int    numero_groupe     = 0;

    //---------------------------------- choix_bouton_actions_vehicule() -------------------------------------
    void choix_bouton_actions_vehicule() {
        groupe = groupes[0];
        groupe.dessine_gros_boutons(60F, 495F, width-60F-60F, 40F);
        groupe.appui_gros_boutons();
    }
    //--------------------------------- choix_bouton_copie() --------------------------
    void choix_bouton_copie() {
        groupe = groupes[1];
        groupe.dessine_gros_boutons(60F+(gestion.l0+120F)/4F+60F+(gestion.l0+120F)/4F+60F,
                                    650F+100F/2F-40F/2F,
                                    width-2F*((gestion.l0+120F)/4F)-2F*60F-2F*60F,
                                    40F);
        groupe.appui_gros_boutons();
    }
    //--------------------------------- choix_bouton_decodeur() --------------------------
    void choix_bouton_decodeur() {
        groupe = groupes[2];
        groupe.dessine_gros_boutons(1000F, 1F, width-1000F-60F, 45F);
        groupe.appui_gros_boutons();
    }
    //---------------------------- dessine_gros_bouton() -------------------
    void dessine_gros_boutons(float _x0, float _y0, float _l0, float _h0) {
        noStroke();
        float taille_texte[] = new float[50];
        float taille_ecart   = 0F;                                                                                            //  au début, taille_ecart sert pour calculer la taille totale du texte
        int nb_zones = Boutons.length;
        textFont(Courier12);        
        for (int i = 0; i < nb_zones; i++) {
            bouton = Boutons[i];
            taille_texte[i] = textWidth(bouton.texte_affiche)*1.2F;
        }
        taille_ecart = 0F;
        for (int i = 0; i < nb_zones; i++) {
            taille_ecart = taille_ecart+taille_texte[i];
        }
        float pos = _x0;
        taille_ecart = (_l0-taille_ecart)/(nb_zones-1);
        pos = _x0;
        for (int i = 0; i < nb_zones; i++) {
            bouton = Boutons[i];
            bouton.dessine_bouton(pos, _y0, taille_texte[i], _h0);
            pos = pos+taille_texte[i]+taille_ecart;
        }
    }
    //---------------------------- dessine_deux_bouton() -------------------
    void dessine_deux_boutons(float _x0, float _y0, float _l0, float _h0) {
        float taille_texte[] = new float[2];
        float taille_ecart   = 0F;                                                                                            //  au début, taille_ecart sert pour calculer la taille totale du texte
        int nb_zones = Boutons.length;
        textFont(Courier12);        
        for (int i = 0; i < nb_zones; i++) {
            bouton = Boutons[i];
            taille_texte[i] = textWidth(bouton.texte_affiche)*1.2F;
        }
        taille_ecart = 0F;
        for (int i = 0; i < nb_zones; i++) {
            taille_ecart = taille_ecart+taille_texte[i];
        }
        float pos = _x0;
        taille_ecart = (_l0-taille_ecart)/3F;                                                                                 //  3f car il n'y a que 2 boutons
        pos = _x0+taille_ecart;
        for (int i = 0; i < nb_zones; i++) {
            bouton = Boutons[i];
            bouton.dessine_bouton(pos, _y0, taille_texte[i], _h0);
            pos = pos+taille_texte[i]+taille_ecart;
        }
    }
    //------------------------------ confirmation() -----------------------
    void confirmation() {
        groupe_confirmation = groupes[groupe_bouton];                                                                         //  groupe_bouton, c'est le groupe dans lequel est le bouton de départ
        String texte = groupe_confirmation.Boutons[ordre_bouton].texte_confirmation;                                          //  ordre_bouton, c'est l'ordre du bouton de départ dans le groupe de boutrons du départ
        textFont(Courier12);
        float taille_texte = textWidth(texte);
        gestion.dessine_rectangle_inverse(width/2F-taille_texte/2F-20F, height/2F-56F, taille_texte+40F, 112F);
        dessine_deux_boutons(width/2F-taille_texte/2F, height/2F+10F, taille_texte, 40F);
        appui_gros_boutons();
        fill(BLANC);
        text(texte, width/2F, height/2F-22F);
    }
    //---------------------------- choix_vehicule() ----------------------
    void choix_vehicule(float _x0, float _y0, float _l0) {
        bouton = Boutons[0];
        bouton.dessine_bouton(_x0, _y0, 20, 20);
        bouton = Boutons[1];
        bouton.dessine_bouton(_x0+_l0, _y0, 20, 20);
        appui_gros_boutons();
    }
    //---------------------------- appui_gros_bouton() -------------------
    void appui_gros_boutons() {
        int nb_zones = Boutons.length;
        for (int i = 0; i < nb_zones; i++) {
            bouton = Boutons[i];
            bouton.appui_bouton();
        }
    }
    //--------------------------- écrire les CV -------------------------------
    void ecrire_les_CV(int _ordre, int _valeur) {
        if (appui_validation && ecriture_OK) {
            if (_ordre != 0) {                
                ecrire_CV(_ordre, _valeur);
            }
            onglet.compteur++;
        }
    }
    //********************************************************************************************************
    //********************************************************************************************************
    //--------------------------------- choix_onglet_fiche() --------------------------
    void choix_onglet_fiche(int _ordre, int _valeur) {
        x0 = 60F; x = 440F; l = 80F; h = 20F; l0 = 600F; h0 = 30F;
        bouton = groupe.Boutons[0];
        y = 130F;
        bouton.dessine_bouton_bleu();
        for (int i = 1; i < 6; i++) {
            bouton = groupe.Boutons[i];
            y = 160F+42F*i;
            bouton.dessine_bouton_bleu();
        }
        bouton = groupe.Boutons[6];
        bouton.dessine_bouton(60F, 160F+42F*7, 300F, 40F);
        bouton.appui_bouton();
        bouton = groupe.Boutons[7];
        bouton.dessine_bouton(60F, 160F+42F*9, 300F, 40F);
        bouton.appui_bouton();
        if (valeurs_usine && !appui_validation) {
            String texte = "RESET 'LIGHT'"
              +char(10)+char(10)+"'Validez les choix pour cet onglet' si OK"
                       +char(10)+"'Ne rien changer pour cet onglet'   sinon";
            gestion.dessine_rectangle_inverse((1366F-500)/2F, (768F-300F)/2F, 500F, 300F);
            textFont(Courier14);
            textAlign(CENTER, CENTER);
            text(texte, width/2F, height/2F);
            onglet.compteur = 0;
        }
        if (master_reset && !appui_validation) {
            String texte = "MASTER RESET"
              +char(10)+char(10)+"'Validez les choix pour cet onglet' si OK"
                       +char(10)+"'Ne rien changer pour cet onglet'   sinon";
            gestion.dessine_rectangle_inverse((1366F-500)/2F, (768F-300F)/2F, 500F, 300F);
            textFont(Courier14);
            textAlign(CENTER, CENTER);
            text(texte, width/2F, height/2F);
            onglet.compteur = 0;
        }
        //--------------------------- écrire les CV -------------------------------
        ecrire_les_CV(_ordre, _valeur);
    }
    //********************************************************************************************************
    //--------------------------------- choix_onglet_configuration() --------------------------
    void choix_onglet_configuration() {
        x0 = 60F; x = 440F; l = 280F; h = 20F; l0 = 800F; h0 = 30F;
        bouton  = groupe.Boutons[0];
        y = 130F;
        bouton.dessine_bouton_bleu();        
        String CV29ici = binary(vehicule.CV[29], 8);
        for (int i = 1; i < 9; i++) {
            bouton = groupe.Boutons[i];
            if (vehicule.CV[29] != -1) {
                if (bouton.texte_choisi == null) {
                    bouton.valeur_bouton = int(CV29ici.substring(8-i, 8-i+1));                                                //(8-n°bit, 8-n°bit+1) si on démarre à 1
                }
            } else {
                if (bouton.texte_choisi == null) {
                    bouton.valeur_bouton = 0;
                }
            }
            y = 160F+42F*i;
            bouton.dessine_bouton_bleu();
            groupe.Boutons[i].appui_bouton();
        }
        bouton = groupe.Boutons[9];
        y = 570F;
        groupe.Boutons[9].dessine_bouton_bleu();
    }
    //********************************************************************************************************
    //--------------------------------- choix_onglet_adresse() --------------------------
    void choix_onglet_adresse() {
        x0 = 60F; x = 440F; l = 280F; h = 20F; l0 = 800F; h0 = 30F;
        //----------------------------- affichage ancienne adresse ------------------------
        int CV29_bit5 = int(binary(vehicule.CV[29], 8).substring(7-5, 7-5+1));                                                //(7-n°bit, 7-n°bit+1) si on démarre à 0
        if (CV29_bit5 == 0) {
            gestion.dessine_rectangle_inverse(50F, 140F, 820F, 155F);
            bouton = groupe.Boutons[0];                                                                                       //  adresse actuelle
            y = 150F;
            bouton.dessine_bouton_bleu();
            bouton = groupe.Boutons[1];                                                                                       //  CV29 bit5
            bouton.valeur_bouton = 0;
            y = 200F;
            bouton.dessine_bouton_bleu();
            bouton = groupe.Boutons[2];                                                                                       //  CV1
            y = 250F;
            bouton.dessine_bouton_bleu();
        } else {
            gestion.dessine_rectangle_inverse(50F, 140F, 820F, 205F);
            bouton = groupe.Boutons[0];                                                                                       //  adresse actuelle
            y = 150F;
            bouton.dessine_bouton_bleu();
            bouton = groupe.Boutons[1];                                                                                       //  CV29 bit5
            bouton.valeur_bouton = 1;
            y = 200F;
            bouton.dessine_bouton_bleu();
            bouton = groupe.Boutons[3];                                                                                       //  CV17
            y = 250F;
            bouton.dessine_bouton_bleu();
            bouton = groupe.Boutons[4];                                                                                       //  CV18
            y = 300F;
            bouton.dessine_bouton_bleu();
        }
        //--------------------------- demande de nouvelle adresse -------------------------
        bouton = groupe.Boutons[5];                                                                                           //  adresse demandée
        y = 400F;
        bouton.dessine_bouton_bleu();
        if (bouton.adresse_saisie != 0) {
            if (bouton.adresse_saisie > 0 && bouton.adresse_saisie < 100) {
                //----------------adresse courte ----------------------
                gestion.dessine_rectangle_inverse(50F, 390F, 820F, 155F);
                bouton = groupe.Boutons[5];                                                                                   //  adresse demandée
                y = 400F;
                bouton.dessine_bouton_bleu();
                bouton = groupe.Boutons[1];                                                                                   //  CV29 bit5
                y = 450F;
                bouton.valeur_bouton = 0;
                if (CV29_bit5 == 0) {
                    bouton.dessine_bouton_bleu_modifie(false);
                } else {
                    bouton.dessine_bouton_bleu_modifie(true);
                    bouton.modif_CV29 = -1;
                }
                bouton = groupe.Boutons[2];                                                                                   //  CV1
                y = 500F;
                bouton.adresse_saisie = groupe.Boutons[5].adresse_saisie;
                bouton.dessine_bouton_bleu_modifie(false);                
            } else {
                if (bouton.adresse_saisie > 127 && bouton.adresse_saisie < 9984) {
                    //-------------------adresse étendue --------------------
                    gestion.dessine_rectangle_inverse(50F, 390F, 820F, 205F);
                    bouton = groupe.Boutons[5];                                                                               //  adresse demandée
                    y = 400F;
                    bouton.dessine_bouton_bleu();
                    bouton = groupe.Boutons[1];                                                                               //  CV29 bit5
                    y = 450F;
                    bouton.valeur_bouton = 1;
                    if (CV29_bit5 == 0) {
                        bouton.dessine_bouton_bleu_modifie(true);
                        bouton.modif_CV29 = 1;
                    } else {
                        bouton.dessine_bouton_bleu_modifie(false);
                    }
                    bouton = groupe.Boutons[4];                                                                               //  CV18
                    y = 550F;
                    bouton.CV18 = int(256*((float(groupe.Boutons[5].adresse_saisie)/256F)-int(groupe.Boutons[5].adresse_saisie/256)));
                    bouton.dessine_bouton_bleu_modifie(false);
                    bouton = groupe.Boutons[3];                                                                               //  CV17
                    y = 500F;
                    bouton.CV17 = int((float(groupe.Boutons[5].adresse_saisie)-bouton.CV18)/256F+192F);
                    bouton.dessine_bouton_bleu_modifie(false);
                } else {
                    if (bouton.adresse_saisie != -1) {
                        //------------------ erreur d'adresse -------------------
                        gestion.dessine_rectangle_inverse(890F, 360F, 460F, 110F);
                        fill(BLANC);
                        textAlign(LEFT, CENTER);
                        text("Seuls certains décodeurs gèrent une valeur entre 0 et 10239", 900, 370);
                        text("s'ils sont bien associés à la centrale de la même marque.", 900, 390);
                        text("Entrez une valeur de 1 à 99 ou de 128 à 9983", 900, 410);
                        text("pour assurer la plus grande compatibilité", 900, 430);
                        text("avec toutes les centrales.", 900, 450);
                    }
                }
            }
        } else {
            //----------------- cas de l'adresse 0 ------------------------------
            gestion.dessine_rectangle_inverse(890F, 360F, 460F, 110F);
            fill(BLANC);
            textAlign(LEFT, CENTER);
            text("L'adresse à 0 signifie que vous quittez le mode DCC.", 900, 370);
            text("La nouvelle source doit être définie au CV12.", 900, 390);
            text("Entrez une valeur de 1 à 99 ou de 128 à 9983", 900, 410);
            text("pour assurer la plus grande compatibilité", 900, 430);
            text("avec toutes les centrales.", 900, 450);
        }
        CV29 = vehicule.CV[29];
        //--------------------------- écrire les CV -------------------------------
        if (appui_validation && ecriture_OK) {
            bouton = groupe.Boutons[5];
            switch (saut1) {
                case 0:
                    if (bouton.adresse_saisie > 0 && bouton.adresse_saisie < 100) {
                        ecrire_CV(1, vehicule.CV[1]);
                        saut1 = 3;
                    } else {
                        saut1 = 1;
                    }
                    break;
                case 1:
                    if (bouton.adresse_saisie > 127 && bouton.adresse_saisie < 9984) {
                        ecrire_CV(17, vehicule.CV[17]);
                        saut1 = 2;
                    }
                    break;
                case 2:
                    ecrire_CV(18, vehicule.CV[18]);
                    saut1 = 3;
                    break;
                case 3:
                    bouton = groupe.Boutons[1];
                    if (bouton.modif_CV29 != 0) { 
                        bouton.modif_CV29  = 0;
                        ecrire_CV(29, vehicule.CV[29]);
                    }
                    if (texte_ecrire == "") {
                        bouton = groupe.Boutons[5];
                        bouton.adresse_saisie = -1;
                        appui_validation   = false;
                    }
                    break;
            }
        }
    }
    //********************************************************************************************************
    //--------------------------------- affiche_onglet_moteur() --------------------------
    void choix_onglet_moteur(int _ordre, int _valeur) {
        textFont(Courier14);
        gestion.dessine_rectangle_inverse(20F, onglet.curseur_up-70F, 355F, 530F);
        //---------------- curseurs ---------------
        stroke(NOIR);
        strokeWeight(3);
        for (int i = 0; i < 2; i++) {
            line(onglet.x_curseur+i*width/16F, onglet.curseur_up, onglet.x_curseur+i*width/16F, onglet.curseur_down);
        }
        for (int i = 0; i < 2; i++) {
            onglet.calcule_pointsV(i);
        }
        for (int i = 0; i < 2; i++) {
            onglet.dessine_curseurV(i);
        }
        onglet.hauteur_curseur[0] = vehicule.CV[3];
        onglet.dessine_digits(0);
        onglet.hauteur_curseur[1] = vehicule.CV[4];
        onglet.dessine_digits(1);
        stroke(BLANC);
        strokeWeight(3);
        line(onglet.x_curseur-30F, onglet.curseur_up-40F, onglet.x_curseur-30F, onglet.curseur_down);
        fill(BLANC);
        triangle(onglet.x_curseur-35F, onglet.curseur_up-30F, onglet.x_curseur-25F, onglet.curseur_up-30F, onglet.x_curseur-30F, onglet.curseur_up-40F);
        textFont(Courier14);
        textAlign(CENTER, CENTER);
        text("Taux Accélération Décélération", onglet.x_curseur+30F, onglet.curseur_up-60F);
        text(" 0 s", onglet.x_curseur-60F, onglet.curseur_down);
        text("31 s", onglet.x_curseur-60F, onglet.curseur_down-onglet.course_curseur/2F);
        text("63 s", onglet.x_curseur-60F, onglet.curseur_up);
        textSize(12);
        text("CV 3",  onglet.x_curseur,             onglet.y_curseur-40F);
        text("CV 4",  onglet.x_curseur+width/16F,   onglet.y_curseur-40F);
        textAlign(LEFT, CENTER);
        text("Nombre de crans de vitesse =", 30F, 549F);
        text("Durée d'un cran de vitesse en accélération =", 30F, 568F);
        text("Durée totale de l'accélération =", 30F, 587F);
        text("Durée d'un cran de vitesse en décélération =", 30F, 606F);
        text("Durée totale de la décélération =", 30F, 625F);
        textFont(fontUnits);
        fill(AQUA);
        textAlign(RIGHT, CENTER);
        textSize(10F);
        int duree = 0;
        int CV29_bit1 = int(binary(vehicule.CV[29], 8).substring(8-2, 8-2+1));
        if (CV29_bit1 == 0) {
            for (int i = 0; i < 2; i++) {
                duree = int(1000F*onglet.hauteur_curseur[i]*0.896F/28F+0.5);
                text(str(duree), 345F, 565F+40F*i);
                duree = int(onglet.hauteur_curseur[i]*0.896F+0.5);
                text(str(duree), 270F, 585F+40F*i);
            }
            textFont(Courier14);
            textAlign(LEFT, CENTER);
            text("28 crans", 220F, 549F);
        } else {
            for (int i = 0; i < 2; i++) {
                duree = int(1000*onglet.hauteur_curseur[i]*0.896F/128F+.5);
                text(str(duree), 345F, 565F+40F*i);
                duree = int(onglet.hauteur_curseur[i]*0.896F+.5);
                text(str(duree), 270F, 585F+40F*i);
            }
            textFont(Courier14);
            textAlign(LEFT, CENTER);
            text("128 crans", 220F, 549F);
        }
        text("ms", 350F, 565F);
        text("s",  275F, 585F);
        text("ms", 350F, 605F);
        text("s",  275F, 625F);
        for (int i = 0; i < 2; i++) {
            onglet.hauteur_curseur[i] = onglet.hauteur_curseur[i]*255F/70F;
        }
        //--------------------------- écrire les CV -------------------------------
        ecrire_les_CV(_ordre, _valeur);
    }
    //********************************************************************************************************
    //--------------------------------- choix_onglet_controle_basique_vitesse() --------------------------
    void choix_onglet_controle_basique_vitesse(int _ordre, int _valeur) {
        textFont(Courier14);
        //---------------- curseurs ---------------
        stroke(NOIR);
        strokeWeight(3);
        for (int i = 0; i < 3; i++) {
            line(onglet.x_curseur+i*width/4F, onglet.curseur_up, onglet.x_curseur+i*width/4F, onglet.curseur_down);
        }
        for (int i = 0; i < 3; i++) {
            onglet.calcule_pointsV(i);
        }
        stroke(AQUA);
        strokeWeight(3);
        for (int i = 0; i < 2; i++) {
            line(onglet.x_curseur+i*width/4F,     (onglet.curseur_down-(onglet.course_curseur)*onglet.hauteur_curseur[i]/255F)*onglet.zoom_c,
                 onglet.x_curseur+(i+1)*width/4F, (onglet.curseur_down-(onglet.course_curseur)*onglet.hauteur_curseur[i+1]/255F)*onglet.zoom_c);
        }
        for (int i = 0; i < 3; i++) {
            onglet.dessine_digits(i);
        }
        for (int i = 0; i < 3; i++) {
            onglet.dessine_curseurV(i);
        }
        stroke(BLANC);
        strokeWeight(3);
        line(onglet.x_curseur, onglet.curseur_down+30F, onglet.x_curseur+50F+2F*width/4F, onglet.curseur_down+30F);
        line(onglet.x_curseur-30F, onglet.curseur_up-50F, onglet.x_curseur-30F, onglet.curseur_down);
        fill(BLANC);
        triangle(onglet.x_curseur-35F,               onglet.curseur_up-40F, 
                 onglet.x_curseur-25F,               onglet.curseur_up-40F, 
                 onglet.x_curseur-30F,               onglet.curseur_up-50F);
        triangle(onglet.x_curseur+40F+2F*width/4F,   onglet.curseur_down+25F, 
                 onglet.x_curseur+40F+2F*width/4F,   onglet.curseur_down+35F, 
                 onglet.x_curseur+50F+2F*width/4F,   onglet.curseur_down+30F);
        textFont(Courier14);
        textAlign(CENTER, CENTER);
        text("Tension moteur", onglet.x_curseur-30F, onglet.curseur_up-70F);
        text("Crans de vitesse", onglet.x_curseur+width/4F, onglet.curseur_down+60F);
        text("0",   onglet.x_curseur,                onglet.curseur_down+40F);
        text("64",  onglet.x_curseur+width/4F,       onglet.curseur_down+40F);
        text("128", onglet.x_curseur+2F*width/4F,    onglet.curseur_down+40F);
        text("0 %",   onglet.x_curseur-60F,          onglet.curseur_down);
        text("50 %",  onglet.x_curseur-60F,          onglet.curseur_down-onglet.course_curseur/2F);
        text("100 %", onglet.x_curseur-60F,          onglet.curseur_up);
        textSize(12);
        text("CV 2",  onglet.x_curseur,              onglet.y_curseur-40F);
        text("CV 6",  onglet.x_curseur+width/4F,     onglet.y_curseur-40F);
        text("CV 5",  onglet.x_curseur+2F*width/4F,  onglet.y_curseur-40F);
        x0 = 348F; x = 728F; l = 280F; h = 20F; l0 = 800F; h0 = 30F;
        bouton = groupe.Boutons[0];
        bouton.valeur_bouton = 0;
        y = 650F;
        bouton.dessine_bouton_bleu();        
        //--------------------------- écrire les CV -------------------------------
        ecrire_les_CV(_ordre, _valeur);
    }
    //********************************************************************************************************
    //--------------------------------- affiche_onglet_table_vitesse() --------------------------
    void choix_onglet_table_vitesse(int _ordre, int _valeur) {
        textFont(Courier14);
        stroke(NOIR);
        strokeWeight(3);
        for (int i = 0; i < 28; i++) {
            line(onglet.x_curseur+i*width/38F, onglet.curseur_up, onglet.x_curseur+i*width/38F, onglet.curseur_down);
        }
        //-------------------------------------- logistique ------------------------------
        for (int i = 0; i < 28; i++) {
            onglet.calcule_pointsV(i);
        }
        stroke(AQUA);
        strokeWeight(3);
        for (int i = 0; i < 27; i++) {
            line(onglet.x_curseur+i*width/38F,     (onglet.curseur_down-(onglet.course_curseur)*onglet.hauteur_curseur[i]/255F)*onglet.zoom_c,
                 onglet.x_curseur+(i+1)*width/38F, (onglet.curseur_down-(onglet.course_curseur)*onglet.hauteur_curseur[i+1]/255F)*onglet.zoom_c);
        }
        for (int i = 0; i < 28; i++) {
            onglet.dessine_digits(i);
        }
        for (int i = 0; i < 28; i++) {
            onglet.dessine_curseurV(i);
        }
        stroke(BLANC);
        strokeWeight(3);
        line(onglet.x_curseur, onglet.curseur_down+20F, onglet.x_curseur+50F+27F*width/38F, onglet.curseur_down+20F);
        line(onglet.x_curseur-30F, onglet.curseur_up-50F, onglet.x_curseur-30F, onglet.curseur_down);
        fill(BLANC);
        triangle(onglet.x_curseur-35F,                 onglet.curseur_up-40F, 
                 onglet.x_curseur-25F,                 onglet.curseur_up-40F, 
                 onglet.x_curseur-30F,                 onglet.curseur_up-50F);
        triangle(onglet.x_curseur+40F+27F*width/38F,   onglet.curseur_down+15F, 
                 onglet.x_curseur+40F+27F*width/38F,   onglet.curseur_down+25F, 
                 onglet.x_curseur+50F+27F*width/38F,   onglet.curseur_down+20F);
        textFont(Courier14);
        textAlign(CENTER, CENTER);
        text("Tension moteur", onglet.x_curseur-30F,   onglet.curseur_up-70F);
        text("Crans de vitesse", onglet.x_curseur+13F*width/38F, onglet.curseur_down+50F);
        for (int i = 0; i < 28; i++) {
            text(str(i), onglet.x_curseur+i*width/38F, onglet.curseur_down+30F);
        }
        text("0 %",   onglet.x_curseur-60F,            onglet.curseur_down);
        text("50 %",  onglet.x_curseur-60F,            onglet.curseur_down-onglet.course_curseur/2F);
        text("100 %", onglet.x_curseur-60F,            onglet.curseur_up);
        textFont(Courier12);
        for (int i = 0; i < 28; i++) {
            text("CV"+str(67+i), onglet.x_curseur+i*width/38F, onglet.y_curseur-40F);
        }
        //-------------------------------- curseurs annexes ----------------------
        float courbe[] = new float[255];
        switch(onglet.parametre) {
            case 0:
                //------------------- vapeur ----------------
                gestion.dessine_rectangle_inverse(onglet.x_curseur+30*width/38F-23F, onglet.curseur_up-60F, 5*width/38F+12F, 623F);
                stroke(NOIR);
                strokeWeight(3);
                for (int i = 30; i < 35; i++) {
                    line(onglet.x_curseur+i*width/38F, onglet.curseur_up, onglet.x_curseur+i*width/38F, onglet.curseur_down);
                }
                fill(BLANC);
                textAlign(CENTER, CENTER);
                for (int i = 30; i < 35; i++) {
                    text("P"+str(i-30), onglet.x_curseur+i*width/38F, onglet.y_curseur-40F);
                }
                for (int i = 30; i < 35; i++) {
                    onglet.calcule_pointsV(i);
                }
                onglet.p[0]           = 0F    + onglet.hauteur_curseur[30];
                onglet.p[1]           = 0.01F + onglet.hauteur_curseur[31]*0.09F/255F;
                onglet.p[2]           = 80F   + onglet.hauteur_curseur[32]*80F/255F;
                onglet.p[3]           = 0.01F + onglet.hauteur_curseur[33]*0.09F/255F;
                onglet.p[4]           = 0F    + onglet.hauteur_curseur[34]-onglet.p[0];
                float c        = 2*onglet.p[1]*onglet.p[3]/abs(onglet.p[1]+onglet.p[3]);
                for (int i = 0; i < 255; i++) {        
                    float f    = 1/(1+exp(-c*(onglet.p[2]-i)));
                    float g    = exp(onglet.p[1]*(onglet.p[2]-i));
                    float h    = exp(onglet.p[3]*(onglet.p[2]-i));
                    float q    = onglet.p[0]+(onglet.p[4]/(1+f*g+(1-f)*h));
                    courbe[i]  = q;
                }
                for (int i = 0; i < 28; i++) {
                    onglet.hauteur_curseur[i] = courbe[int(i*255F/28F)];
                }
                for (int i = 30; i < 35; i++) {
                    onglet.dessine_digits(i);
                }
                for (int i = 30; i < 35; i++) {
                    onglet.dessine_curseurV(i);
                }
                textFont(Courier14);
                fill(BLANC);
                textAlign(LEFT, CENTER);
                text("P0 : vitesse_mini",      onglet.x_curseur+30*width/38F-13F, onglet.curseur_down+58F);
                text("P1 : convexité basse",   onglet.x_curseur+30*width/38F-13F, onglet.curseur_down+78F);
                text("P2 : point d'inflexion", onglet.x_curseur+30*width/38F-13F, onglet.curseur_down+98F);
                text("P3 : convexité haute",   onglet.x_curseur+30*width/38F-13F, onglet.curseur_down+118F);
                text("P4 : vitesse_maxi",      onglet.x_curseur+30*width/38F-13F, onglet.curseur_down+138F);
                break;
            case 1:
                //------------------- electrique/diesel ----------------
                gestion.dessine_rectangle_inverse(onglet.x_curseur+30*width/38F-23F, onglet.curseur_up-60F, 5*width/38F+12F, 623F);
                stroke(NOIR);
                strokeWeight(3);
                for (int i = 30; i < 35; i=i+2) {
                    line(onglet.x_curseur+i*width/38F, onglet.curseur_up, onglet.x_curseur+i*width/38F, onglet.curseur_down);
                }
                fill(BLANC);
                textAlign(CENTER, CENTER);
                for (int i = 30; i < 35; i++) {
                    text("P"+str(i-30), onglet.x_curseur+i*width/38F, onglet.y_curseur-40F);
                }
                for (int i = 30; i < 35; i++) {
                    onglet.calcule_pointsV(i);
                }
                onglet.p[0]           = 0F    + onglet.hauteur_curseur[30];
                onglet.p[2]           = 10F   + onglet.hauteur_curseur[32]*230F/255F;
                onglet.p[4]           = 0F    + onglet.hauteur_curseur[34]-onglet.p[0];
                for (int i = 0; i < 255; i++) {        
                    float q    = onglet.p[0]+onglet.p[4]*(1-exp(-i/(255F-onglet.p[2])));
                    courbe[i]  = q;
                }
                for (int i = 0; i < 28; i++) {
                    onglet.hauteur_curseur[i] = courbe[int(i*255F/28F)];
                }
                for (int i = 30; i < 35; i=i+2) {
                    onglet.dessine_digits(i);
                }
                for (int i = 30; i < 35; i=i+2) {
                    onglet.dessine_curseurV(i);
                }
                textFont(Courier14);
                fill(BLANC);
                textAlign(LEFT, CENTER);
                text("P0 : vitesse_mini",  onglet.x_curseur+30*width/38F-13F, onglet.curseur_down+58F);
                text("P2 : pente",         onglet.x_curseur+30*width/38F-13F, onglet.curseur_down+78F);
                text("P3 : vitesse_maxi",  onglet.x_curseur+30*width/38F-13F, onglet.curseur_down+98F);
                break;
            case 2:
                break;
        }
        x0 = 348F; x = 728F; l = 280F; h = 20F; l0 = 800F; h0 = 30F;
        bouton = groupe.Boutons[0];
        bouton.valeur_bouton = 1;
        y = 650F;
        bouton.dessine_bouton_bleu();        
        //--------------------------- écrire les CV -------------------------------
        ecrire_les_CV(_ordre, _valeur);
    }
    //--------------------------------- modif_courbe() --------------------------
    void modif_courbe() {
        groupe2.dessine_gros_boutons(747F, 585F, 400F, 45F);
        groupe2.appui_gros_boutons();
    }
    //********************************************************************************************************
    //------------------------- carte_fonctions() ------------------------------
    void choix_carte_fonctions(int _ordre, int _valeur) {
        gestion.dessine_rectangle_inverse(23F, 108F, 1320F, 530F);
        //-------------- flêches verticales --------
        stroke(BLEU_CLAIR);
        strokeWeight(3);
        textFont(Courier17);
        for (int colonne = 0; colonne < 3; colonne++) {
            line(885F+32F*colonne, 180F+32F*10F, 885F+32F*colonne, 160F);
        }
        for (int colonne = 3; colonne < 6; colonne++) {
            line(885F+32F*colonne, 180F+32F*5F, 885F+32F*colonne, 160F);
        }
        for (int colonne = 6; colonne < 14; colonne++) {
            line(885F+32F*colonne, 180F, 885F+32F*colonne, 160F);
        }
        fill(BLEU_CLAIR);
        for (int colonne = 0; colonne < 14; colonne++) {
            triangle(885F+32F*colonne-5F, 165F, 885F+32F*colonne+5F, 165F, 885F+32F*colonne, 155F);
        }
        //-------------- flêches horizontales --------
        stroke(BLANC);
        fill(BLANC);
        for (int ligne = 0; ligne < 14; ligne++) {
            line(770F, 195F+32F*ligne, 840F, 195F+32F*ligne);
        }
        for (int ligne = 0; ligne < 14; ligne++) {
            triangle(840F, 195F+32F*ligne-5F, 840F, 195F+32F*ligne+5F, 850F, 195F+32F*ligne);
        }
        for (int ligne = 0; ligne < 14; ligne++) {
            image(affiche_bleu, 670F, 195F+32F*ligne-10F, 80F, 20F);
        }
        //---------- ligne "CV" ------
        fill(NOIR);
        for (int ligne = 0; ligne < 14; ligne++) {
            text("(CV"+str(33+ligne)+")", 630F, 192F+32F*ligne);
        }
        textAlign(LEFT, CENTER);
        text("Fonction 0/FL(f)", 430F, 192F);
        text("Phare frontal en marche avant", 40F, 192F);
        text("Fonction 0/FL(r)", 430F, 192F+32F);
        text("Phare frontal en marche arrière", 40F, 192F+32F);
        for (int ligne = 2; ligne < 14; ligne++) {
            text("Fonction "+str(ligne-1), 430F, 192F+32F*ligne);
        }
        text("Contenu du CV", 645F, 192F-32F);        
        //------------------ couleurs des fils du décodeur --------------------
        for (int colonne = 0; colonne < 14; colonne++) {
            noFill();
            noStroke();
            switch (colonne) {
                case 0 :
                    fill(BLANC);
                    circle(852+32F*(14-colonne), 120F, 12F);
                    break;
                case 1 :
                    fill(OR);
                    circle(852+32F*(14-colonne), 120F, 12F);
                    break;
                case 2 :
                    fill(VERT);
                    circle(852+32F*(14-colonne), 120F, 12F);
                    break;
                case 3 :
                    fill(POURPRE);
                    circle(852+32F*(14-colonne), 120F, 12F);
                    break;
                case 4 :
                    fill(BRUN);
                    circle(852+32F*(14-colonne), 120F, 12F);
                    break;
                default:
                    noFill();
                    noStroke();
            }
        }
        //---------- titres -----------
        textAlign(RIGHT, CENTER);
        fill(VERT);
        text("Couleurs des fils du décodeur :", 855F, 118F);
        fill(BLANC);        
        text("Sorties :", 855F, 135F);
        //--------------- boutons ---------------------
        textAlign(CENTER, CENTER);
        int compteur_boutons = -1;
        for (int ligne = -1; ligne < 14; ligne++) {                                                                                      //  subtilité pour parcourir le tableau : en ligne, puis en colonne en décroissant
            for (int colonne = 13; colonne > -1; colonne--) {                                                                            //  on a ainsi un tableau parcouru du coin en haut à droite au coin en bas à gauche
                if (ligne == -1) {
                    text(str(colonne+1), 852+32F*(14-colonne), 135F);
                }
                if (colonne >  5 && colonne < 14 && ligne > -1 && ligne <  5) {
                    compteur_boutons++;
                    bouton = groupe.Boutons[compteur_boutons];
                    bouton.dessine_bouton(870F+32F*colonne, 180F+32F*ligne, 30F, 30F);
                    bouton.appui_bouton();
                    if (bouton.valide) {
                        bouton.valeur_bouton = int(pow(2, (13-colonne)));
                    } else {
                        bouton.valeur_bouton = 0;
                    }
                }
                if (colonne >  2 && colonne < 11 && ligne >  4 && ligne < 10) {
                    compteur_boutons++;
                    bouton = groupe.Boutons[compteur_boutons];
                    bouton.dessine_bouton(870F+32F*colonne, 180F+32F*ligne, 30F, 30F);
                    bouton.appui_bouton();
                    if (bouton.valide) {
                        bouton.valeur_bouton = int(pow(2, (10-colonne)));
                    } else {
                        bouton.valeur_bouton = 0;
                    }
                }
                if (colonne > -1 && colonne <  8 && ligne >  9 && ligne < 14) {
                    compteur_boutons++;
                    bouton = groupe.Boutons[compteur_boutons];
                    bouton.dessine_bouton(870F+32F*colonne, 180F+32F*ligne, 30F, 30F);
                    bouton.appui_bouton();
                    if (bouton.valide) {
                        bouton.valeur_bouton = int(pow(2, (7-colonne)));
                    } else {
                        bouton.valeur_bouton = 0;
                    }
                }
            }
        }
        //----------------- calcul des CV et affichage -------------------
        for (int ligne = 0; ligne < 14; ligne++) {
            CV[ligne] = 0;
        }
        int m = 0;
        for (int k = 0; k < 112; k++) {
            bouton = groupe.Boutons[k];
            if (k%8 != 7) {
                CV[m] = CV[m]+bouton.valeur_bouton;
            } else {
                CV[m] = CV[m]+bouton.valeur_bouton;
                m++;
            }
        }
        fill(NOIR);
        for (int ligne = 0; ligne < 14; ligne++) {
            text(CV[ligne], 710F, 192F+32F*ligne);
        }
        //---------------- bouton valeurs par défaut -----------
        textFont(Courier12);        
        bouton = groupe.Boutons[112];
        bouton.dessine_bouton(1170F, 583F, 140F, 40F);
        bouton.appui_bouton();
        //---------------- bouton valeurs dans le décodeur -------
        bouton = groupe.Boutons[113];
        bouton.dessine_bouton(1170F, 515F, 140F, 60F);
        bouton.appui_bouton();        
        //--------------------------- écrire les CV -------------------------------
        ecrire_les_CV(_ordre, _valeur);
    }
    //------------------------- valide_onglet() -----------------------------------
    void valide_onglet() {
        groupe1.dessine_deux_boutons(320F, 710F, 560F, 40F);
        groupe1.appui_gros_boutons();        
    }
    //------------------------- fonctions_par_defaut() ----------------------------
    void fonctions_par_defaut() {
        for (int k = 0; k < 112; k++) {
            bouton = groupe.Boutons[k];
            bouton.valide = false;          
        }
        for (int k = 0; k < 40; k = k+9) {
            bouton = groupe.Boutons[k];
            bouton.valide = true;
        }
        for (int k = 42; k < 80; k = k+9) {
            bouton = groupe.Boutons[k];
            bouton.valide = true;
        }
        for (int k = 84; k < 112; k = k+9) {
            bouton = groupe.Boutons[k];
            bouton.valide = true;
        }
    }
    //---------------------------- fonctions_decodeur() --------------------
    void fonctions_decodeur() {
        int compteur_boutons = -1;
        for (int j = 33; j < 47; j++) {
            String binaire = binary(vehicule.CV[j], 8);
            for (int i = 7; i > -1; i--) {
                compteur_boutons++;
                bouton = groupe.Boutons[compteur_boutons];
                if (binaire.substring(i, i+1).equals("0")) {
                    bouton.valide = false;
                } else {
                    bouton.valide = true;
                }
            }
        }
    }
    //********************************************************************************************************
    //---------------------------- choix_onglet_tableau_CV() ----------------
    void choix_onglet_tableau_CV() {
        for (int ligne = 0; ligne < 12; ligne++) {                                                                                      //  subtilité pour parcourir le tableau : en ligne, puis en colonne
            for (int colonne = 0; colonne < 10; colonne++) {
                int case_CV = 10*ligne+colonne+1;
                gestion.dessine_rectangle(15F+135F*colonne, 110F+45F*ligne, 120F, 30F);
                textAlign(LEFT, CENTER);
                fill(BLANC);
                text("CV"+str(case_CV), 20F+135F*colonne, 122F+45F*ligne);
                imageMode(CENTER);
                fill(NOIR);
                textAlign(CENTER, CENTER);
                if (CV_decodeur[case_CV] == vehicule.CV[case_CV]) {
                    image(affiche_vert,  75F+135F*colonne, 124F+45F*ligne, 30F, 21F);
                    image(affiche_vert, 112F+135F*colonne, 124F+45F*ligne, 30F, 21F);
                    text(str(CV_decodeur[case_CV]),  75F+135F*colonne, 122F+45F*ligne);                
                    text(vehicule.CV[case_CV],       112F+135F*colonne, 122F+45F*ligne);                    
                } else {
                    if (CV_decodeur[case_CV] == -2) {
                        image(affiche_bleu,             112F+135F*colonne, 124F+45F*ligne, 30F, 21F);
                        text(str(vehicule.CV[case_CV]), 112F+135F*colonne, 122F+45F*ligne);                       
                    } else {
                        image(affiche_bleu,  75F+135F*colonne, 124F+45F*ligne, 30F, 21F);
                        image(affiche_bleu, 112F+135F*colonne, 124F+45F*ligne, 30F, 21F);
                        text(str(CV_decodeur[case_CV]),  75F+135F*colonne, 122F+45F*ligne);                
                        text(str(vehicule.CV[case_CV]),      112F+135F*colonne, 122F+45F*ligne);                        
                    }
                }
            }
        }
        gestion.dessine_rectangle(1020F, 650F, 330F, 30F);
        textAlign(CENTER, CENTER);
        fill(BLANC);
        text("CV n°",            1040F, 122F+45F*12F);
        image(affiche_bleu,      1150F, 124F+45F*12F, 120F, 21F);
        image(affiche_bleu,      1280F, 124F+45F*12F, 120F, 21F);
        fill(NOIR);
        text("Dans le décodeur", 1150F, 122F+45F*12F);                
        text("Dans le fichier",  1280F, 122F+45F*12F);
        //----------------- boutons ---------------------
        //----------------- aucun bouton ------------------
        if (!transfert_fich_dec && !transfert_dec_fich) {
            textAlign(CENTER, CENTER);
            int compteur_boutons = -1;
            for (int ligne = 0; ligne < 12; ligne++) {                                                                                      //  subtilité pour parcourir le tableau : en ligne, puis en colonne
                for (int colonne = 0; colonne < 10; colonne++) {
                    String texte_info;
                    compteur_boutons++;
                    bouton = groupe.Boutons[compteur_boutons];
                    bouton.dessine_bouton(10F+135F*colonne, 106F+45F*ligne, 130F, 40F);
                    bouton.appui_bouton();
                    if (appui_validation) {
                        fin_comptage = millis();
                    }
                    if (appui_CV != 0 || (appui_validation && fin_comptage-debut_comptage < 2000)) {
                        String texte_ici = "Chaîne envoyée = <R "+str(appui_CV)+" 1"+str(appui_CV)+" 1"+str(appui_CV)+">";
                        if (appui_CV != 0) {
                            texte_info = texte_ici;
                        } else {
                            texte_info = texte_lire;
                        }
                        gestion.dessine_rectangle_inverse((1366F-500F)/2F, (768F-300F)/2F, 500F, 300F);
                        textFont(Courier17);
                        textAlign(CENTER, CENTER);
                        text(texte_info, width/2F, height/2F);
                        if (appui_CV == 0 && fin_comptage-debut_comptage > 1000) {
                            appui_validation = false;
                            texte_lire = "";
                        }
                    }
                }
            }
        }
        //--------------------------- transfert decodeur --> ficher ------------------------
        if (transfert_dec_fich) {
            textAlign(CENTER, CENTER);
            int compteur_boutons = -1;
            for (int ligne = 0; ligne < 12; ligne++) {                                                                                      //  subtilité pour parcourir le tableau : en ligne, puis en colonne
                for (int colonne = 0; colonne < 10; colonne++) {
                    int case_CV = 10*ligne+colonne+1;
                    compteur_boutons++;
                    bouton = groupe.Boutons[compteur_boutons];
                    bouton.dessine_bouton(10F+135F*colonne, 106F+45F*ligne, 130F, 40F);
                    bouton.appui_bouton();
                    if (appui_CV != 0 && appui_CV == case_CV) {
                        vehicule.CV[case_CV] = CV_decodeur[case_CV];
                        transfert_dec_fich = false;
                        appui_CV = 0;
                        break;
                    }
                }
            }
        }
        //--------------------------- transfert fichier --> decodeur ------------------------
        if (transfert_fich_dec) {
            textAlign(CENTER, CENTER);
            int compteur_boutons = -1;
            for (int ligne = 0; ligne < 12; ligne++) {                                                                                      //  subtilité pour parcourir le tableau : en ligne, puis en colonne
                for (int colonne = 0; colonne < 10; colonne++) {
                    int case_CV = 10*ligne+colonne+1;
                    compteur_boutons++;
                    bouton = groupe.Boutons[compteur_boutons];
                    bouton.dessine_bouton(10F+135F*colonne, 106F+45F*ligne, 130F, 40F);
                    bouton.appui_bouton();
                    if (appui_CV != 0 && appui_CV == case_CV) {
                        ecrire_CV(case_CV, vehicule.CV[case_CV]);
                        CV_decodeur[case_CV] = vehicule.CV[case_CV];
                        transfert_fich_dec = false;
                        appui_CV = 0;
                        break;
                    }
                }
            }
        }
    }
}
//*******************************************************************************************
//*************************************** groupes particuliers ******************************
//*******************************************************************************************
class Vehicule_ligne1 extends Groupe {
    Vehicule_ligne1() {
        super(new Bouton[] { new Texte_decodeur(), new Ajoute_decodeur(), new MaJ_decodeur(), new Retirer_decodeur(),
                             new Action_CV(), new Copier_CV(), new Coller_CV(),
                             new Filtre(), new Echelle(), new Bouton_moteur(), new DCC(), new Marque(), new Bouton_Proprietaire(), new Effacer_filtres() });
        numero_groupe = 0;
    }
}
//*******************************************************************************************
class Copie_ligne2 extends Groupe {
    Copie_ligne2() {
        super(new Bouton[] { new Faire_copie(), new Sortir_copie() });
        numero_groupe = 1;
    }
}
//*******************************************************************************************
class Decodeur_ligne1 extends Groupe {
    Decodeur_ligne1() {
        super(new Bouton[] { /*new Maj_retour(), */new Retour_sans_maj() });
        numero_groupe = 2;
    }
}
//*******************************************************************************************
class Boutons_confirmation extends Groupe {
    Boutons_confirmation() {
        super(new Bouton[] { new OK(), new Annule() });
        numero_groupe = 3;
    }
}
//*******************************************************************************************
class Choix_vehicule extends Groupe {
    Choix_vehicule() {
        super(new Bouton[] { new Precedent(), new Suivant() });
        numero_groupe = 4;
    }
}
//*******************************************************************************************
class Boutons_onglet_fiche extends Groupe {
    Boutons_onglet_fiche() {
        super(new Bouton[] { new Modif_proprietaire(), new Longueur(), new Largeur(), new Hauteur(), new Numero_fabricant(), new Numero_version(),
                             new Valeurs_usine(), new Master_reset() });
        numero_groupe = 5;
    }
}
//*******************************************************************************************
class Boutons_onglet_adresse extends Groupe {
    Boutons_onglet_adresse() {
        super(new Bouton[] { new Adresse_actuelle(), new Adresse_courte(), new CV1(), new CV17(), new CV18(), new Adresse() });
        numero_groupe = 6;
    }
}
//*******************************************************************************************
class Boutons_onglet_configuration extends Groupe {
    Boutons_onglet_configuration() {
        super(new Bouton[] { new Valeur_CV29_enregistree(), new Sens_normal(), new Nb_crans(), new Analogique(), new Bouton_railcom(), new Table_vitesse(),
                             new Adresse_courte(), new CV29_bit6(), new CV29_bit7(), new Valeur_CV29_modifiee() });
        numero_groupe = 7;
    }
}
//*******************************************************************************************
class Boutons_onglet_moteur extends Groupe {
    Boutons_onglet_moteur() {
        super(new Bouton[] {});
        numero_groupe = 8;
    }
}
//*******************************************************************************************
class Boutons_onglet_controle_basique_de_vitesse extends Groupe {
    Boutons_onglet_controle_basique_de_vitesse() {
        super(new Bouton[] { new Table_vitesse() });
        numero_groupe = 9;
    }
}
//*******************************************************************************************
class Boutons_onglet_tableau_vitesse extends Groupe {
    Boutons_onglet_tableau_vitesse() {
        super(new Bouton[] { new Table_vitesse() });
        numero_groupe = 10;
    }
}
//*******************************************************************************************
class Boutons_onglet_carte_fonctions extends Groupe {
    Boutons_onglet_carte_fonctions() {
        super(new Bouton[] { new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(),
                             new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(),
                             new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(),
                             new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(),
                             new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(),
                             new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(),
                             new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(),
                             new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(),
                             new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(),
                             new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(),
                             new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(), new Bouton_fonction(),
                             new Bouton_fonction(), new Bouton_fonction(), new Fonctions_par_defaut(), new Fonctions_decodeur() });
        numero_groupe = 11;
    }
}
//*******************************************************************************************
class Boutons_onglet_tableau_CV extends Groupe {
    Boutons_onglet_tableau_CV() {
        super(new Bouton[] { new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(),
                             new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(),
                             new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(),
                             new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(),
                             new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(),
                             new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(),
                             new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(),
                             new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(),
                             new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(),
                             new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(),
                             new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(),
                             new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV(), new Selection_CV() });
        numero_groupe = 12;
    }
}
//*******************************************************************************************
class Boutons_onglet_lumieres extends Groupe {
    Boutons_onglet_lumieres() {
        super(new Bouton[] {});
        numero_groupe = 13;
    }
}
//*******************************************************************************************
class Boutons_onglet_controle_analogique extends Groupe {
    Boutons_onglet_controle_analogique() {
        super(new Bouton[] {});
        numero_groupe = 14;
    }
}
//*******************************************************************************************
class Boutons_onglet_convoi extends Groupe {
    Boutons_onglet_convoi() {
        super(new Bouton[] {});
        numero_groupe = 15;
    }
}
//*******************************************************************************************
class Boutons_onglet_avance extends Groupe {
    Boutons_onglet_avance() {
        super(new Bouton[] {});
        numero_groupe = 16;
    }
}
//*******************************************************************************************
class Boutons_onglet_sons extends Groupe {
    Boutons_onglet_sons() {
        super(new Bouton[] {});
        numero_groupe = 17;
    }
}
//*******************************************************************************************
class Boutons_onglet_volume_sons extends Groupe {
    Boutons_onglet_volume_sons() {
        super(new Bouton[] {});
        numero_groupe = 18;
    }
}
//*******************************************************************************************
class Boutons_onglet_accel_decel extends Groupe {
    Boutons_onglet_accel_decel() {
        super(new Bouton[] {});
        numero_groupe = 19;
    }
}
//*******************************************************************************************
class Boutons_onglet_shunt_uncouple extends Groupe {
    Boutons_onglet_shunt_uncouple() {
        super(new Bouton[] {});
        numero_groupe = 20;
    }
}
//*******************************************************************************************
class Boutons_onglet_alt_fonctions_map extends Groupe {
    Boutons_onglet_alt_fonctions_map() {
        super(new Bouton[] {});
        numero_groupe = 21;
    }
}
//*******************************************************************************************
class Boutons_onglet_fonctions_output extends Groupe {
    Boutons_onglet_fonctions_output() {
        super(new Bouton[] {});
        numero_groupe = 22;
    }
}
//*******************************************************************************************
class Boutons_onglet_zimo_specific extends Groupe {
    Boutons_onglet_zimo_specific() {
        super(new Bouton[] {});
        numero_groupe = 23;
    }
}
//*******************************************************************************************
class Boutons_onglet_railcom extends Groupe {
    Boutons_onglet_railcom() {
        super(new Bouton[] {});
        numero_groupe = 24;
    }
}
//*******************************************************************************************
class Boutons_onglet_abc extends Groupe {
    Boutons_onglet_abc() {
        super(new Bouton[] {});
        numero_groupe = 25;
    }
}
//*******************************************************************************************
class Boutons_onglet_speed_regulation extends Groupe {
    Boutons_onglet_speed_regulation() {
        super(new Bouton[] {});
        numero_groupe = 26;
    }
}
//*******************************************************************************************
class Boutons_onglet_servos extends Groupe {
    Boutons_onglet_servos() {
        super(new Bouton[] {});
        numero_groupe = 27;
    }
}
//*******************************************************************************************
class Boutons_modif_courbe extends Groupe {
    Boutons_modif_courbe() {
        super(new Bouton[] { new Vapeur(), new Electrique_diesel(), new Boutons_libres() });
        numero_groupe = 28;
    }
}
//*******************************************************************************************
class Boutons_transfert_donnees extends Groupe {
    Boutons_transfert_donnees() {
        super(new Bouton[] { new Fichier_decodeur(), new Decodeur_fichier() });
        numero_groupe = 29;
    }
}//*******************************************************************************************
class Boutons_validation_onglet extends Groupe {
    Boutons_validation_onglet() {
        super(new Bouton[] { new Validation_CV(), new Sortir_CV() });
        numero_groupe = 100;
    }
}
