//********************* Recherche automatique de l'Arduino (merci Pierre59) ******************
void connexion() { String[] sl=null; String s=null; boolean trace=false; // booleen pour trace ou pas)
    trouve = false;
    print("Plateforme ");
    switch (platform) { // afichage du nom de la platteforme
        case WINDOWS: println("WINDOWS"); break; // COM*
        case MACOSX:  println("MACOSX");  break; // usbmodem*
        case LINUX:   println("LINUX");   break; // ttyACM*
        default:      println("AUTRE"); 
    }
    
    sl=Serial.list();
    for (int i=0; i<sl.length; i++) println("n° "+i+" "+Serial.list()[i]); println(); // affichage des ports serie
    for (int i=sl.length-1; i>=0; i--) { s=sl[i]; int x=0,y=0,z=0; // pour tous les ports serie (n° port decroissant)
        if (trace) print("port "+s+" : ");
        try { 
          port=new Serial(this,s,115200); 
          delay(2000); // il faut attendre un peu pour que le port série soit stable
          port.write("power on <1>");
        } catch(Throwable e) { if (trace) println(" erreur "+e);  continue; }
        
        delay(3000); // laisser le temps a l'arduino de transmettre le message et attendre le retour de l'accusé réception
        chaine_lue = port.readStringUntil(SUPERIEUR);
        if (chaine_lue != null && chaine_lue.equals("<p1>")) {
            trouve = true;
            break;
        }
    }
    debut_comptage = millis();
    if (trouve) {
        texte_ecrire = "Arduino trouve sur le port "+s;
        choix_du_vehicule = true;
    } else {
        texte_ecrire = "Aucun Arduino n'est branché à l'ordinateur"
           +char(10)+char(10)+"Branchez un Arduino avec son MotorShield"
                    +char(10)+"De plus, l'Arduino doit contenir"
                    +char(10)+"le sketch DCC_controller.ino"
           +char(10)+char(10)+"Puis relancez le programme Decoduino";
        choix_du_vehicule = false;       
    }    
}
