//****************************************** mouseClicked() *************************************
void mouseClicked() {
    //------------------------ dessine_les_fabricants ------------------------------
    if (dessine_les_fabricants) {
        int compte_fabricants = -1;
        for (String fab0 : tous_fabricants) {
            compte_fabricants++;
            for (Decodeur dec0 : tous_decodeurs) {
                if (dec0 != null && dec0.nom_fabricant.equals(fab0)) {
                    if (mouseX > 10                      && mouseX < 10+gestion.largeur_fabricant
                     && mouseY > 10+15*compte_fabricants && mouseY < 24+15*compte_fabricants) {
                        gestion.fabricant_choisi = fab0;
                        gestion.ligne_fabricant  = compte_fabricants;
                        gestion.famille_choisie  = ".";
                        gestion.ligne_famille    = -1;
                        break;
                    }
                }
            }                        
        }
    }
    //---------------------- dessine_les_familles ------------------------------------
    if (dessine_les_familles) {
        int compte_familles = -1;
        for (String fam0 : toutes_familles) {
            int fab = fam0.indexOf("/");
            if (fam0.substring(0, fab).equals(gestion.fabricant_choisi)) {
                compte_familles++;
                for (Decodeur dec0 : tous_decodeurs) {
                    if (dec0 != null && dec0.nom_famille.equals(fam0)) {
                        if (mouseX > 20+gestion.largeur_fabricant  && mouseX < 20+gestion.largeur_fabricant+gestion.largeur_famille
                         && mouseY > 10+15*compte_familles     && mouseY < 24+15*compte_familles) {
                            gestion.famille_choisie = fam0;
                            gestion.ligne_famille   = compte_familles;
                            gestion.modele_choisi   = ".";
                            gestion.ligne_modele    = -1;
                        }
                    }
                }                        
            }
        }
    }
    //---------------------- dessine_les_modeles ------------------------------------
    if (dessine_les_modeles) {
        int compte_modeles = -1;
        for (String mod0 : tous_modeles) {
            int mod = mod0.indexOf("//");
            if (mod0.substring(0, mod).equals(gestion.famille_choisie)) {
                compte_modeles++;
                for (Decodeur dec0 : tous_decodeurs) {
                    if (dec0 != null && dec0.nom_modele.equals(mod0)) {
                        if (mouseX > 30+gestion.largeur_fabricant+gestion.largeur_famille && mouseX < 30+gestion.largeur_fabricant+gestion.largeur_famille+gestion.largeur_modele
                         && mouseY > 10+15*compte_modeles                         && mouseY < 24+15*compte_modeles) {
                            gestion.modele_choisi   = mod0;
                            gestion.ligne_modele    = compte_modeles;
                            gestion.decodeur_choisi = dec0;
                        }
                    }
                }                        
            }
        }
    }
    //---------------------- choix_onglet ------------------------------------
    if (choix_onglet && affiche_en_tete) {
        for (Decodeur dec0 : tous_decodeurs) {
            if (dec0 != null && dec0.nom_modele.equals(gestion.modele_choisi)) {
                for (Zone zon0 : dec0.toutes_zones) {
                    if (mouseX > zon0.x  && mouseX < zon0.x+zon0.l
                     && mouseY > zon0.y  && mouseY < zon0.y+zon0.h) {
                        dec0.onglet_choisi = zon0.nom_zone;
                        textFont(Courier14);
                        gestion.dessine_en_tete();
                        dec0.reordonne_onglets();
                        dec0.grand_onglet(zon0.nom_zone);
                        gestion.dessine_rectangle(20F, 650F, 300F, 100F);
                        imageMode(CENTER);
                        image(vehicule.image_cote, 20F+300F/2F, 650F+100F/2F, vehicule.image_cote.width/4F, vehicule.image_cote.height/4F);
                        ecran = createImage(width, height, RGB);                                                                                           //  ce sera l'image de l'écran, avec les rails
                        //------------ calcule l'image du fond d'ecran ---------------------
                        ecran.loadPixels();                                                                                                                //  prépare la variable écran
                        loadPixels();                                                                                                                      //  charge l'écran complet dans la variable Pixels()
                        for (int i = 0; i < pixels.length; i++) {
                            ecran.pixels[i] = pixels[i];                                                                                                   //  prépare la copie tous les pixels de l'écran dans la variable écran                                                                                               
                        }
                        ecran.updatePixels();                                                                                                              //  met à jours la variable écran. A noter que cette variable écran n'a pas de trains
                        break;
                    }
                }
            }
        }                                    
    }
}
//****************************************** mouseDragged() *************************************
void mouseDragged() {
    //--------------------- curseur vertical -----------------------------
    if (dans_curseurV) {
        for (Decodeur dec0 : tous_decodeurs) {
            if (dec0 != null && dec0.onglet_choisi != null) {
                for (Onglet ong0 : tous_onglets) {
                    if (ong0.nom_onglet.equals(dec0.onglet_choisi)) {
                        ong0.hauteur_curseur[ong0.numero_curseur] = max(0, min(255, 255*((ong0.curseur_down-mouseY)/(ong0.curseur_down-ong0.curseur_up))));
                    }
                }  
            }
        }
    }
    //------------------- curseur horizontal ----------------------------
    if (dans_curseurH_vehicule) { 
        int identite = vehicule.ID;
        if (mouseY > gestion.y0-30 && mouseY < gestion.y0+30) {
            gestion.largeur_curseur[gestion.numero_curseur] = int(max(0, min((width-240), (mouseX-gestion.curseur_left)))+.5);
            identite = int(map(gestion.largeur_curseur[0], 0, gestion.l0, 0, tous_vehicules.size()-1)+.5);
            vehicule = tous_vehicules.get(identite);
            if (copier_CV && !coller_CV) {
                vehicule_copie = identite;
            }
        }
    }
}
//*******************************************************************************************
//****************************************** keyPressed() *************************************
//*******************************************************************************************
void keyPressed() {
    if (key == CODED) {
        texte_saisi = "";
    } else {
        if (key==BACKSPACE) {
            if (texte_saisi.length() > 0) {
                texte_saisi = texte_saisi.substring(0, texte_saisi.length()-1);
            }
        } else {
            if (key == RETURN || key ==  ENTER) {
                if (onglet.Groupes[0].numero_groupe == 5) {
                    onglet.Groupes[0].Boutons[0].numero_saisi   = int(texte_saisi);
                }
                if (onglet.Groupes[0].numero_groupe == 6) {                            
                    onglet.Groupes[0].Boutons[5].adresse_saisie = int(texte_saisi);
                }
                texte_saisi = "";
            } else {
                if (key != ESC) {                    
                    texte_saisi +=key;
                    if (onglet.Groupes[0].numero_groupe == 5) {                            
                        onglet.Groupes[0].Boutons[0].numero_saisi   = -1;
                    }
                    if (onglet.Groupes[0].numero_groupe == 6) { 
                        onglet.Groupes[0].Boutons[5].adresse_saisie = -1;
                    }
                }
            }
        }
    }
}
//*******************************************************************************************
//*************************************** Zone{} ********************************************
//*******************************************************************************************
class Zone {
    String nom_zone;
    float  x        = 0F;
    float  y        = 0F;
    float  l        = 0F;
    float  h        = 0F;
    int    ligne    = 0;
    String debut[]  = new String[10];                                                             //  il n'y a pas plus de 10 lignes dans la liste des onglets
}
