//*************************************** Onglet() ********************************************
class Onglet {
    Groupe[] Groupes;
  
    String nom_onglet;
    float  x1                = 0;
    float  y1                = 0;
    float  l1                = 0;
    float  h1                = 0;
    float  curseur_down      = 0;
    float  curseur_up        = 0;
    float  x_curseur         = 0F;
    float  y_curseur         = 0F;
    float  zoom_c            = 1F;
    float  largeur_curseur   = 0F;
    float  ecart_curseur     = 0F;
    float  hauteur_curseur[] = new float[35];
    float  course_curseur    = 0;
    int    numero_curseur    = 0;
    String nom_vehicule;
    String date;
    String nom_groupe;
    int    parametre         = -1;
    float  p[]               = new float[5];
    int    compteur          = 0;

    Onglet(Groupe[] g0) {
        Groupes = g0;
    }  //  constructeur
    //---------------------------------- calcule_pointsV() ---------------------------------------------------------
    void calcule_pointsV(int _numero_curseur) {                                                                                             //  démarre à 0
        course_curseur    = curseur_down-curseur_up;
        x1 = x_curseur-largeur_curseur/2F+_numero_curseur*ecart_curseur;
        y1 = y_curseur;
        l1 = largeur_curseur;
        h1 = course_curseur;
        if (mouseX > x1-10  && mouseX < x1+l1+10
         && mouseY > y1-10  && mouseY < y1+h1+10) {
            if (mousePressed) {
                dans_curseurV = true;
                numero_curseur = _numero_curseur;
            }
        }
    }
    //---------------------------------- dessine_curseurV() ---------------------------------------------------------
    void dessine_curseurV(int _numero_curseur) {                                                                                             //  démarre à 0
        imageMode(CORNER);
        image(curseurV,
              x_curseur-10+(_numero_curseur*ecart_curseur)*zoom_c,
              y_curseur-15+(curseur_down-y_curseur-(course_curseur)*hauteur_curseur[_numero_curseur]/255F)*zoom_c,                      
              zoom_c*(largeur_curseur),
              1.5F*zoom_c*largeur_curseur);                                                                                                      //  l'image du curseur suit exactement la position de la souris
    }
    //---------------------------------- dessine_digits() ---------------------------------------------------------
    void dessine_digits(int _numero_curseur) {                                                                                              //  c'est un dessin : le numero de pupitte démarre à 0        
        textFont(fontUnits);
        fill(AQUA);
        textAlign(CENTER, CENTER);
        textSize(10F);
        text(int(hauteur_curseur[_numero_curseur]+.5),
             x_curseur+2F+(_numero_curseur*ecart_curseur)*zoom_c,
             y_curseur-20F*zoom_c);
    }
    //---------------------------- methodes vides ------------------------------
    void description_onglet() {}
    void dessine_onglet() {}
    void dessine_onglet_detaille() {}
    void maj_curseurs() {}
}
//***************************************************************************************************
//************************************* Onglets particuliers ****************************************
//***************************************************************************************************
class Fiche extends Onglet {
    Fiche() {
        super(new Groupe[] { new Boutons_onglet_fiche(), new Boutons_validation_onglet() });
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
        nom_onglet = "Fiche";
    }
    //---------------------------- dessine_onglet() ----------------------------------
    void dessine_onglet() {
        imageMode(CORNER);
        image(ecran, 0, 0, width, height);                                                                                                     //  redessine tout le réseau avant d'afficher le pupitre
        groupe = Groupes[0];
        if (!appui_validation) {
            groupe.choix_onglet_fiche(0, 0);
            compteur = 0;
        }
        if (valeurs_usine && appui_validation && ecriture_OK) {
            switch(compteur) {
                case 0:
                    CV106 = vehicule.CV[106];
                    for (int i = 1; i < 8; i++) {
                        vehicule.CV[i] = -1;
                    }
                    //----------- on évite les CV7 et CV8 ---
                    for (int i = 9; i < 105; i++) {
                        vehicule.CV[i] = -1;
                    }
                    //----------- on évite les CV105 et CV106 ------
                    for (int i = 107; i < 201; i++) {
                        vehicule.CV[i] = -1;
                    }
                    for (int i = 33; i < 47; i++) {
                        vehicule.CV[i] = 0;
                    }
                    groupe.choix_onglet_fiche(106, vehicule.CV[106]);
                    break;
                case 1:
                    groupe.choix_onglet_fiche(1,  decodeur.CV1_);
                    break;
                case 2:
                    groupe.choix_onglet_fiche(2,  decodeur.CV2_);
                    break;   
                case 3:
                    groupe.choix_onglet_fiche(3,  decodeur.CV3_);
                    break;   
                case 4:
                    groupe.choix_onglet_fiche(4,  decodeur.CV4_);
                    break;   
                case 5:
                    groupe.choix_onglet_fiche(5,  decodeur.CV5_);
                    break;   
                case 6:
                    groupe.choix_onglet_fiche(6,  decodeur.CV6_);
                    break;   
                case 7:
                    groupe.choix_onglet_fiche(17, decodeur.CV17_);
                    break;   
                case 8:
                    groupe.choix_onglet_fiche(18, decodeur.CV18_);
                    break;   
                case 9:
                    groupe.choix_onglet_fiche(28, decodeur.CV28_);
                    break;   
                case 10:
                    groupe.choix_onglet_fiche(29, decodeur.CV29_);
                    break;   
                case 11:
                    groupe.choix_onglet_fiche(66, decodeur.CV66_);
                    break;   
                case 12:
                    groupe.choix_onglet_fiche(95, decodeur.CV95_);
                    valeurs_usine       = false;
                    appui_validation = false;
                    compteur            = 0;
                    break;   
            }
        }
        if (master_reset && appui_validation && ecriture_OK) {
            switch(compteur) {
                case 0:
                    CV106 = vehicule.CV[106];
                    for (int i = 1; i < 8; i++) {
                        vehicule.CV[i] = -1;
                    }
                    //----------- on évite les CV7 et CV8 ---
                    for (int i = 9; i < 105; i++) {
                        vehicule.CV[i] = -1;
                    }
                    //----------- on évite les CV105 et CV106 ------
                    for (int i = 107; i < 201; i++) {
                        vehicule.CV[i] = -1;
                    }
                    for (int i = 33; i < 47; i++) {
                        vehicule.CV[i] = 0;
                    }
                    groupe.choix_onglet_fiche(7, 0);
                    break;
                case 1:
                    groupe.choix_onglet_fiche(31, 0);
                    break;
                case 2:
                    groupe.choix_onglet_fiche(32, 0);
                    break;   
                case 3:
                    groupe.choix_onglet_fiche(8, 8);
                    break;   
                case 4:
                    groupe.choix_onglet_fiche(15, 0);
                    break;   
                case 5:
                    groupe.choix_onglet_fiche(16, 0);
                    break;   
                case 6:
                    groupe.choix_onglet_fiche(8, 8);
                    break;   
                case 7:
                    groupe.choix_onglet_fiche(144, 0);
                    break;   
                case 8:
                    groupe.choix_onglet_fiche(106, CV106);
                    master_reset        = false;
                    appui_validation = false;
                    compteur            = 0;
                    break;   
            }
        }
        if (!texte_ecrire.equals("")) {
            gestion.dessine_rectangle_inverse((1366F-500F)/2F, (768F-300F)/2F, 500F, 300F);
            textFont(Courier17);
            textAlign(CENTER, CENTER);
            text(texte_ecrire, width/2F, height/2F);
            fin_comptage = millis();
            if (fin_comptage-debut_comptage > 1000) {
                texte_ecrire = "";
            }
        }
        groupe1 = Groupes[1];
        groupe1.valide_onglet();
    }
}
//***************************************************************************************************
class Configuration extends Onglet {
    Configuration() {
        super(new Groupe[] { new Boutons_onglet_configuration(), new Boutons_validation_onglet() });
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
        nom_onglet = "Configuration";
    }
    //----------------------------- dessine_onglet() -----------------------------
    void dessine_onglet() {
        imageMode(CORNER);
        image(ecran, 0, 0, width, height);                                                                                                     //  redessine tout le réseau avant d'afficher le pupitre
        groupe = Groupes[0];
        groupe.choix_onglet_configuration();
        if (!texte_ecrire.equals("")) {
            gestion.dessine_rectangle_inverse((1366F-500F)/2F, (768F-300F)/2F, 500F, 300F);
            textFont(Courier17);
            textAlign(CENTER, CENTER);
            text(texte_ecrire, width/2F, height/2F);
            fin_comptage = millis();
            if (fin_comptage-debut_comptage > 1000) {
                texte_ecrire = "";
            }
        }
        groupe1 = Groupes[1];
        groupe1.valide_onglet();
    }
}
//***************************************************************************************************
class Onglet_adresse extends Onglet {
    Onglet_adresse() {
        super(new Groupe[] { new Boutons_onglet_adresse(), new Boutons_validation_onglet() });
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
        nom_onglet = "Adresse";
    }
    //----------------------------- dessine_onglet() -----------------------------
    void dessine_onglet() {
        imageMode(CORNER);
        image(ecran, 0, 0, width, height);                                                                                                     //  redessine tout le réseau avant d'afficher le pupitre
        groupe = Groupes[0];
        if (!appui_validation) {
            groupe.choix_onglet_adresse();
            saut1          = 0;
        }
        if (appui_validation && ecriture_OK) {
            groupe.choix_onglet_adresse();
        }
        if (!texte_ecrire.equals("")) {
            gestion.dessine_rectangle_inverse((1366F-500F)/2F, (768F-300F)/2F, 500F, 300F);
            textFont(Courier17);
            textAlign(CENTER, CENTER);
            text(texte_ecrire, width/2F, height/2F);
            fin_comptage = millis();
            if (fin_comptage-debut_comptage > 1000) {
                texte_ecrire = "";
            }
        }
        groupe1 = Groupes[1];
        groupe1.valide_onglet();
    }
}
//***************************************************************************************************
class Moteur extends Onglet {
    Moteur() {
        super(new Groupe[] { new Boutons_onglet_moteur(), new Boutons_validation_onglet() });
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
        nom_onglet = "Moteur";
        x_curseur       = width/10F;
        y_curseur       = 180F;
        largeur_curseur = 20F;
        curseur_up      = 180F;
        curseur_down    = 525F;
        ecart_curseur   = width/16F;
    }
    //----------------------------- maj_curseurs() ---------------------------------------------
    void maj_curseurs() {
        hauteur_curseur[0] = vehicule.CV[3]*255F/70F;                                  //  il faut tenir compte du grossissment des curseurs à l'écran
        hauteur_curseur[1] = vehicule.CV[4]*255F/70F;
    }
    //---------------------------- dessine_onglet --------------------------------
    void dessine_onglet() {
        imageMode(CORNER);
        image(ecran, 0, 0, width, height);                                                                                                     //  redessine tout le réseau avant d'afficher le pupitre
        groupe = Groupes[0];
        if (!appui_validation) {
            groupe.choix_onglet_moteur(0, 0);
            compteur = 0;
        }
        if (appui_validation && ecriture_OK) {
            switch(compteur) {
                case 0:
                    groupe.choix_onglet_moteur(0, 0);
                    break;
                case 1:
                    groupe.choix_onglet_moteur(3, vehicule.CV[3]);
                    break;
                case 2:
                    groupe.choix_onglet_moteur(4, vehicule.CV[4]);
                    appui_validation = false;
                    maj_curseurs();
                    break;
            }
        }
        if (!texte_ecrire.equals("")) {
            gestion.dessine_rectangle_inverse((1366F-500F)/2F, (768F-300F)/2F, 500F, 300F);
            textFont(Courier17);
            textAlign(CENTER, CENTER);
            text(texte_ecrire, width/2F, height/2F);
            fin_comptage = millis();
            if (fin_comptage-debut_comptage > 1000) {
                texte_ecrire = "";
            }
        }
        groupe1 = Groupes[1];
        groupe1.valide_onglet();
    }
}
//***************************************************************************************************
class ControleBasiqueVitesse extends Onglet {
    ControleBasiqueVitesse() {
        super(new Groupe[] { new Boutons_onglet_controle_basique_de_vitesse(), new Boutons_validation_onglet() });
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
        nom_onglet = "Contrôle basique des vitesses";
        x_curseur       = width/4F;
        y_curseur       = 180F;
        largeur_curseur = 20F;
        curseur_up      = 180F;
        curseur_down    = 530F;
        ecart_curseur   = width/4F;
    }
    //----------------------------- maj_curseurs() ---------------------------------------------
    void maj_curseurs() {
        hauteur_curseur[0] = vehicule.CV[2];
        hauteur_curseur[1] = vehicule.CV[6];
        hauteur_curseur[2] = vehicule.CV[5];
    }
    //---------------------------- dessine_onglet --------------------------------
    void dessine_onglet() {
        imageMode(CORNER);
        image(ecran, 0, 0, width, height);                                                                                                     //  redessine tout le réseau avant d'afficher le pupitre
        groupe  = Groupes[0];
        if (!appui_validation) {
            groupe.choix_onglet_controle_basique_vitesse(0, 0);
            compteur       = 0;
        }
        if (appui_validation && ecriture_OK) {
            switch(compteur) {
                case 0:
                    groupe.choix_onglet_controle_basique_vitesse(0, 0);
                    break;
                case 1:
                    groupe.choix_onglet_controle_basique_vitesse(2,  vehicule.CV[2]);
                    break;
                case 2:
                    groupe.choix_onglet_controle_basique_vitesse(6,  vehicule.CV[6]);
                    break;
                case 3:
                    groupe.choix_onglet_controle_basique_vitesse(5,  vehicule.CV[5]);
                    break;
                case 4:
                    groupe.choix_onglet_controle_basique_vitesse(29, vehicule.CV[29]);
                    appui_validation = false;
                    break;
            }
        }
        if (!texte_ecrire.equals("")) {
            gestion.dessine_rectangle_inverse((1366F-500F)/2F, (768F-300F)/2F, 500F, 300F);
            textFont(Courier17);
            textAlign(CENTER, CENTER);
            text(texte_ecrire, width/2F, height/2F);
            fin_comptage = millis();
            if (fin_comptage-debut_comptage > 1000) {
                texte_ecrire = "";
            }
        }
        groupe1 = Groupes[1];
        groupe1.valide_onglet();
    }
}
//***************************************************************************************************
class TableauVitesse extends Onglet {
    TableauVitesse() {
        super(new Groupe[] { new Boutons_onglet_tableau_vitesse(), new Boutons_validation_onglet(), new Boutons_modif_courbe() });
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
        nom_onglet = "Tableau des vitesses";
        x_curseur       = width/38F+70F;
        y_curseur       = 180F;
        largeur_curseur = 20F;
        curseur_up      = 180F;
        curseur_down    = 530F;
        ecart_curseur   = width/38F;
    }
    //----------------------------- maj_curseurs() ---------------------------------------------
    void maj_curseurs() {
        for (int i = 0; i < 28; i++) {
            hauteur_curseur[i] = vehicule.CV[67+i];
        }
        for (int i = 30; i < 35; i++) {
            hauteur_curseur[i] = vehicule.p[i-30];
        }
    }
    //---------------------------- dessine_onglet --------------------------------
    void dessine_onglet() {
        imageMode(CORNER);
        image(ecran, 0, 0, width, height);                                                                                                     //  redessine tout le réseau avant d'afficher le pupitre
        groupe  = Groupes[0];
        if (!appui_validation) {
            groupe.choix_onglet_table_vitesse(0, 0);
            compteur       = 0;
        }
        if (appui_validation && ecriture_OK) {
            switch(compteur) {
                case 0:
                    groupe.choix_onglet_table_vitesse(0, 0);
                    break;
                case 1:
                    groupe.choix_onglet_table_vitesse(67,  vehicule.CV[67]);
                    break;
                case 2:
                    groupe.choix_onglet_table_vitesse(68,  vehicule.CV[68]);
                    break;
                case 3:
                    groupe.choix_onglet_table_vitesse(69,  vehicule.CV[69]);
                    break;
                case 4:
                    groupe.choix_onglet_table_vitesse(70,  vehicule.CV[70]);
                    break;
                case 5:
                    groupe.choix_onglet_table_vitesse(71,  vehicule.CV[71]);
                    break;
                case 6:
                    groupe.choix_onglet_table_vitesse(72,  vehicule.CV[72]);
                    break;
                case 7:
                    groupe.choix_onglet_table_vitesse(73,  vehicule.CV[73]);
                    break;
                case 8:
                    groupe.choix_onglet_table_vitesse(74,  vehicule.CV[74]);
                    break;
                case 9:
                    groupe.choix_onglet_table_vitesse(75,  vehicule.CV[75]);
                    break;
                case 10:
                    groupe.choix_onglet_table_vitesse(76,  vehicule.CV[76]);
                    break;
                case 11:
                    groupe.choix_onglet_table_vitesse(77,  vehicule.CV[77]);
                    break;
                case 12:
                    groupe.choix_onglet_table_vitesse(78,  vehicule.CV[78]);
                    break;
                case 13:
                    groupe.choix_onglet_table_vitesse(79,  vehicule.CV[79]);
                    break;
                case 14:
                    groupe.choix_onglet_table_vitesse(80,  vehicule.CV[80]);
                    break;
                case 15:
                    groupe.choix_onglet_table_vitesse(81,  vehicule.CV[81]);
                    break;
                case 16:
                    groupe.choix_onglet_table_vitesse(82,  vehicule.CV[82]);
                    break;
                case 17:
                    groupe.choix_onglet_table_vitesse(83,  vehicule.CV[83]);
                    break;
                case 18:
                    groupe.choix_onglet_table_vitesse(84,  vehicule.CV[84]);
                    break;
                case 19:
                    groupe.choix_onglet_table_vitesse(85,  vehicule.CV[85]);
                    break;
                case 20:
                    groupe.choix_onglet_table_vitesse(86,  vehicule.CV[86]);
                    break;
                case 21:
                    groupe.choix_onglet_table_vitesse(87,  vehicule.CV[87]);
                    break;
                case 22:
                    groupe.choix_onglet_table_vitesse(88,  vehicule.CV[88]);
                    break;
                case 23:
                    groupe.choix_onglet_table_vitesse(89,  vehicule.CV[89]);
                    break;
                case 24:
                    groupe.choix_onglet_table_vitesse(90,  vehicule.CV[90]);
                    break;
                case 25:
                    groupe.choix_onglet_table_vitesse(91,  vehicule.CV[91]);
                    break;
                case 26:
                    groupe.choix_onglet_table_vitesse(92,  vehicule.CV[92]);
                    break;
                case 27:
                    groupe.choix_onglet_table_vitesse(93,  vehicule.CV[93]);
                    break;
                case 28:
                    groupe.choix_onglet_table_vitesse(94,  vehicule.CV[93]);
                    break;
                case 29:
                    groupe.choix_onglet_table_vitesse(29, vehicule.CV[29]);
                    appui_validation = false;
                    break;
            }
        }
        if (!texte_ecrire.equals("")) {
            gestion.dessine_rectangle_inverse((1366F-500F)/2F, (768F-300F)/2F, 500F, 300F);
            textFont(Courier17);
            textAlign(CENTER, CENTER);
            text(texte_ecrire, width/2F, height/2F);
            fin_comptage = millis();
            if (fin_comptage-debut_comptage > 1000) {
                texte_ecrire = "";
            }
        }
        groupe1 = Groupes[1];
        groupe1.valide_onglet();
        groupe2 = Groupes[2];
        groupe2.modif_courbe();
    }
}
//***************************************************************************************************
class CarteFonctions extends Onglet {
    CarteFonctions() {
        super(new Groupe[] { new Boutons_onglet_carte_fonctions(), new Boutons_validation_onglet() });
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
        nom_onglet = "Carte des fonctions";
    }
    //---------------------------- dessine_onglet --------------------------------
    void dessine_onglet() {
        imageMode(CORNER);
        image(ecran, 0, 0, width, height);                                                                                                     //  redessine tout le réseau avant d'afficher le pupitre
        groupe  = Groupes[0];
        if (!appui_validation) {
            groupe.choix_carte_fonctions(0, 0);
            compteur       = 0;
        }
        if (appui_validation && ecriture_OK) {
            switch(compteur) {
                case 0:
                    groupe.choix_carte_fonctions(0, 0);
                    break;
                case 1:
                    groupe.choix_carte_fonctions(33,  vehicule.CV[33]);
                    break;
                case 2:
                    groupe.choix_carte_fonctions(34,  vehicule.CV[34]);
                    break;
                case 3:
                    groupe.choix_carte_fonctions(35,  vehicule.CV[35]);
                    break;
                case 4:
                    groupe.choix_carte_fonctions(36,  vehicule.CV[36]);
                    break;
                case 5:
                    groupe.choix_carte_fonctions(37,  vehicule.CV[37]);
                    break;
                case 6:
                    groupe.choix_carte_fonctions(38,  vehicule.CV[38]);
                    break;
                case 7:
                    groupe.choix_carte_fonctions(39,  vehicule.CV[39]);
                    break;
                case 8:
                    groupe.choix_carte_fonctions(40,  vehicule.CV[40]);
                    break;
                case 9:
                    groupe.choix_carte_fonctions(41,  vehicule.CV[41]);
                    break;
                case 10:
                    groupe.choix_carte_fonctions(42,  vehicule.CV[42]);
                    break;
                case 11:
                    groupe.choix_carte_fonctions(43,  vehicule.CV[43]);
                    break;
                case 12:
                    groupe.choix_carte_fonctions(44,  vehicule.CV[44]);
                    break;
                case 13:
                    groupe.choix_carte_fonctions(45,  vehicule.CV[45]);
                    break;
                case 14:
                    groupe.choix_carte_fonctions(46,  vehicule.CV[46]);
                    appui_validation = false;
                    break;
            }
        }
        if (!texte_ecrire.equals("")) {
            gestion.dessine_rectangle_inverse((1366F-500F)/2F, (768F-300F)/2F, 500F, 300F);
            textFont(Courier17);
            textAlign(CENTER, CENTER);
            text(texte_ecrire, width/2F, height/2F);
            fin_comptage = millis();
            if (fin_comptage-debut_comptage > 1000) {
                texte_ecrire = "";
            }
        }
        groupe1 = Groupes[1];
        groupe1.valide_onglet();
    }
}
//***************************************************************************************************
class TableauCV extends Onglet {
    TableauCV() {
        super(new Groupe[] { new Boutons_onglet_tableau_CV(), new Boutons_transfert_donnees() });
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
        nom_onglet = "Tableau des CVs";
        initialise_CV_decodeur();
    }
    //----------------------------- dessine_onglet() -----------------------------
    void dessine_onglet() {
        imageMode(CORNER);
        image(ecran, 0, 0, width, height);                                                                                                     //  redessine tout le réseau avant d'afficher le pupitre
        groupe = Groupes[0];
        groupe.choix_onglet_tableau_CV();
        if (!texte_ecrire.equals("")) {
            gestion.dessine_rectangle_inverse((1366F-500F)/2F, (768F-300F)/2F, 500F, 300F);
            textFont(Courier17);
            textAlign(CENTER, CENTER);
            text(texte_ecrire, width/2F, height/2F);
            fin_comptage = millis();
            if (fin_comptage-debut_comptage > 1000) {
                texte_ecrire = "";
            }
        }
        groupe1 = Groupes[1];
        groupe1.valide_onglet();
    }
}
//***************************************************************************************************
class Lumieres extends Onglet {
    Lumieres() {
        super(new Groupe[] { new Boutons_onglet_lumieres() });
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
        nom_onglet = "Lumières";
    }
}
//***************************************************************************************************
class ControleAnalogique extends Onglet {
    ControleAnalogique() {
        super(new Groupe[] { new Boutons_onglet_controle_analogique() });
        nom_onglet = "Contrôles en analogique";
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
    }
}
//***************************************************************************************************
class Convoi extends Onglet {
    Convoi() {
        super(new Groupe[] { new Boutons_onglet_convoi() });
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
        nom_onglet = "Convois";
    }
}
//***************************************************************************************************
class Avance extends Onglet {
    Avance() {
        super(new Groupe[] { new Boutons_onglet_avance() });
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
        nom_onglet = "Avancé";
    }
}
//***************************************************************************************************
class Sons extends Onglet {
    Sons() {
        super(new Groupe[] { new Boutons_onglet_sons() });
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
        nom_onglet = "Sons";
    }
}
//***************************************************************************************************
class VolumeSons extends Onglet {
    VolumeSons() {
        super(new Groupe[] { new Boutons_onglet_volume_sons() });
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
        nom_onglet = "Volume des sons";
    }
}
//***************************************************************************************************
class AccelDecel extends Onglet {
    AccelDecel() {
        super(new Groupe[] { new Boutons_onglet_accel_decel() });
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
        nom_onglet = "Accélération/décélération";
    }
}
//***************************************************************************************************
class ShuntUncouple extends Onglet {
    ShuntUncouple() {
        super(new Groupe[] { new Boutons_onglet_shunt_uncouple() });
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
        nom_onglet = "Shunt/Uncouple";
    }
}
//***************************************************************************************************
class AltFunctionMap extends Onglet {
    AltFunctionMap() {
        super(new Groupe[] { new Boutons_onglet_alt_fonctions_map() });
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
        nom_onglet = "Alt Function Map";
    }
}
//***************************************************************************************************
class FunctionOutput extends Onglet {
    FunctionOutput() {
        super(new Groupe[] { new Boutons_onglet_fonctions_output() });
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
        nom_onglet = "Function Output";
    }
}
//***************************************************************************************************
class ZimoSpecific extends Onglet {
    ZimoSpecific() {
        super(new Groupe[] { new Boutons_onglet_zimo_specific() });
        nom_onglet = "Zimo Specific";
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
    }
}
//***************************************************************************************************
class Railcom extends Onglet {
    Railcom() {
        super(new Groupe[] { new Boutons_onglet_railcom() });
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
        nom_onglet = "Railcom";
    }
}
//***************************************************************************************************
class ABC extends Onglet {
    ABC() {
        super(new Groupe[] { new Boutons_onglet_abc() });
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
        nom_onglet = "ABC";
    }
}
//***************************************************************************************************
class SpeedRegulation extends Onglet {
    SpeedRegulation() {
        super(new Groupe[] { new Boutons_onglet_speed_regulation() });
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
        nom_onglet = "SpeedRegulation";
    }
}
//***************************************************************************************************
class Servos extends Onglet {
    Servos() {
        super(new Groupe[] { new Boutons_onglet_servos() });
        description_onglet();
    }
    //----------------------------- description_onglet() -------------------------
    void description_onglet() {
        nom_onglet = "Servos";
    }
}
